package air.update.core {
	import air.update.states.HSM;
	import air.update.states.HSMEvent;
	import air.update.utils.Constants;
	import flash.events.*;
	import flash.filesystem.*;
	import flash.net.*;
	import flash.utils.*;
	public class UCFUnpackager extends HSM {
		public function UCFUnpackager();
		public function unpackageAsync(url:String):void;
		public function get isComplete():Boolean;
		public function set outputDirectory(dir:File):void;
		public function get outputDirectory():File;
		public function set enableSignatureValidation(enable:Boolean):void;
		public function cancel():void;
		protected function onFile(fileNumber:uint,path:String,data:ByteArray):Boolean;
		protected function onDirectory(path:String):void;
		protected function onDone():void;
		protected static const AT_START:uint=0;
		protected static const AT_HEADER:uint=1;
		protected static const AT_FILENAME:uint=2;
		protected static const AT_EXTRA_FIELD:uint=3;
		protected static const AT_DATA:uint=4;
		protected static const AT_END:uint=5;
		protected static const AT_ERROR:uint=6;
		protected static const AT_COMPLETE:uint=12;
		protected static const AT_ABORTED:uint=13;
		protected static const AT_CDHEADER:uint=7;
		protected static const AT_CDHEADERMAGIC:uint=8;
		protected static const AT_CDFILENAME:uint=9;
		protected static const AT_CDEXTRA_FIELD:uint=10;
		protected static const AT_CDCOMMENT:uint=11;
		protected function get ucfParseState():uint;
		private function initialized(event:Event):void;
		private function unpackaging(event:Event):void;
		private function complete(event:Event):void;
		private function errored(event:Event):void;
		private function onData(event:ProgressEvent):void;
		private function onComplete(event:Event):void;
		private function dispatchError(error:Error):void;
		private var m_ucfParseState:uint;
		private var identifier:String;
		private var source:URLStream;
		private var _generalPurposeBitFlags:uint;
		private var _compressionMethod:uint;
		private var _extraFieldLength:uint;
		private var _compressedSize:uint;
		private var _uncompressedSize:uint;
		private var _filenameLength:uint;
		private var _data:ByteArray;
		private var _path:String;
		private var _currentLFH:ByteArray;
		private var isDirectory:Boolean;
		private var m_fileCount:uint;
		private var _fileCommentLength:uint;
		private var _fileRelativeOffset:uint;
		private var _root:Object;
		private var m_dir:File;
		private var m_validator:Object;
		private var m_enableSignatureValidation:Boolean;
		private var m_isComplete:Boolean;
	}
}
