	package mx.collections {
		import flash.events.Event;
		import flash.events.EventDispatcher;
		import flash.utils.Proxy;
		import flash.utils.flash_proxy;
		import flash.utils.getQualifiedClassName;
		import mx.collections.errors.CollectionViewError;
		import mx.collections.errors.CursorError;
		import mx.collections.errors.ItemPendingError;
		import mx.collections.errors.SortError;
		import mx.core.IMXMLObject;
		import mx.core.mx_internal;
		import mx.events.CollectionEvent;
		import mx.events.CollectionEventKind;
		import mx.events.FlexEvent;
		import mx.events.PropertyChangeEvent;
		import mx.managers.ISystemManager;
		import mx.managers.SystemManager;
		import mx.resources.IResourceManager;
		import mx.resources.ResourceManager;
		import mx.utils.ObjectUtil;
		public class ListCollectionView extends Proxy implements ICollectionView, IList, IMXMLObject {
			include "../core/Version.as";
			private var eventDispatcher:EventDispatcher;
			private var revision:int;
			private var autoUpdateCounter:int;
			private var pendingUpdates:Array;
			mx_internal var dispatchResetEvent:Boolean;
			private var resourceManager:IResourceManager;
			protected var localIndex:Array;
			public function ListCollectionView(list:IList=null);
			public function initialized(document:Object,id:String):void;
			public function get length():int;
			private var _list:IList;
			public function get list():IList;
			public function set list(value:IList):void;
			private var _filterFunction:Function;
			public function get filterFunction():Function;
			public function set filterFunction(f:Function):void;
			private var _sort:Sort;
			public function get sort():Sort;
			public function set sort(s:Sort):void;
			public function contains(item:Object):Boolean;
			public function disableAutoUpdate():void;
			public function enableAutoUpdate():void;
			public function createCursor():IViewCursor;
			public function itemUpdated(item:Object,property:Object=null,oldValue:Object=null,newValue:Object=null):void;
			public function refresh():Boolean;
			public function getItemAt(index:int,prefetch:int=0):Object;
			public function setItemAt(item:Object,index:int):Object;
			public function addItem(item:Object):void;
			public function addItemAt(item:Object,index:int):void;
			public function getItemIndex(item:Object):int;
			private function getFilteredItemIndex(item:Object):int;
			public function removeItemAt(index:int):Object;
			public function removeAll():void;
			public function toArray():Array;
			public function toString():String;
			override flash_proxy function getProperty(name:*):*;
			override flash_proxy function setProperty(name:*,value:*):void;
			override flash_proxy function hasProperty(name:*):Boolean;
			override flash_proxy function nextNameIndex(index:int):int;
			override flash_proxy function nextName(index:int):String;
			override flash_proxy function nextValue(index:int):*;
			override flash_proxy function callProperty(name:*,...rest):*;
			public function addEventListener(type:String,listener:Function,useCapture:Boolean=false,priority:int=0,useWeakReference:Boolean=false):void;
			public function removeEventListener(type:String,listener:Function,useCapture:Boolean=false):void;
			public function dispatchEvent(event:Event):Boolean;
			public function hasEventListener(type:String):Boolean;
			public function willTrigger(type:String):Boolean;
			private function addItemsToView(items:Array,sourceLocation:int,dispatch:Boolean=true):int;
			mx_internal function findItem(values:Object,mode:String,insertIndex:Boolean=false):int;
			mx_internal function getBookmark(index:int):ListCollectionViewBookmark;
			mx_internal function getBookmarkIndex(bookmark:CursorBookmark):int;
			private function listChangeHandler(event:CollectionEvent):void;
			private function handlePropertyChangeEvents(events:Array):void;
			private function handlePendingUpdates():void;
			private function internalRefresh(dispatch:Boolean):Boolean;
			private function moveItemInView(item:Object,dispatch:Boolean=true,updateEventItems:Array=null):void;
			private function populateLocalIndex():void;
			private function removeItemsFromView(items:Array,sourceLocation:int,dispatch:Boolean=true):void;
			private function replaceItemsInView(items:Array,location:int,dispatch:Boolean=true):void;
			mx_internal function reset():void;
		}
	}
	import flash.events.EventDispatcher;
	import flash.events.Event;
	import flash.events.IEventDispatcher;
	import mx.events.*;
	import mx.collections.*;
	import mx.collections.errors.*;
	import mx.core.mx_internal;
	import mx.managers.*;
	import mx.resources.IResourceManager;
	import mx.resources.ResourceManager;
	class ListCollectionViewCursor extends EventDispatcher implements IViewCursor {
		private static const BEFORE_FIRST_INDEX:int=-1;
		private static const AFTER_LAST_INDEX:int=-2;
		public function ListCollectionViewCursor(view:ListCollectionView);
		private var _view:ListCollectionView;
		private var currentIndex:int;
		private var currentValue:Object;
		private var invalid:Boolean;
		private var resourceManager:IResourceManager;
		public function get view():ICollectionView;
		public function get current():Object;
		public function get bookmark():CursorBookmark;
		public function get beforeFirst():Boolean;
		public function get afterLast():Boolean;
		public function findAny(values:Object):Boolean;
		public function findFirst(values:Object):Boolean;
		public function findLast(values:Object):Boolean;
		public function insert(item:Object):void;
		public function moveNext():Boolean;
		public function movePrevious():Boolean;
		public function remove():Object;
		public function seek(bookmark:CursorBookmark,offset:int=0,prefetch:int=0):void;
		private function checkValid():void;
		private function collectionEventHandler(event:CollectionEvent):void;
		private function setCurrent(value:Object,dispatch:Boolean=true):void;
	}
	class ListCollectionViewBookmark extends CursorBookmark {
		mx_internal var index:int;
		mx_internal var view:ListCollectionView;
		mx_internal var viewRevision:int;
		public function ListCollectionViewBookmark(value:Object,view:ListCollectionView,viewRevision:int,index:int);
		override public function getViewIndex():int;
	}
