package mx.containers {
	import flash.display.DisplayObject;
	import flash.display.Graphics;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.TextLineMetrics;
	import flash.utils.getQualifiedClassName;
	import mx.automation.IAutomationObject;
	import mx.containers.utilityClasses.BoxLayout;
	import mx.containers.utilityClasses.CanvasLayout;
	import mx.containers.utilityClasses.ConstraintColumn;
	import mx.containers.utilityClasses.ConstraintRow;
	import mx.containers.utilityClasses.IConstraintLayout;
	import mx.containers.utilityClasses.Layout;
	import mx.controls.Button;
	import mx.core.Container;
	import mx.core.ContainerLayout;
	import mx.core.EdgeMetrics;
	import mx.core.EventPriority;
	import mx.core.FlexVersion;
	import mx.core.IFlexDisplayObject;
	import mx.core.IFlexModuleFactory;
	import mx.core.IFontContextComponent;
	import mx.core.IUIComponent;
	import mx.core.IUITextField;
	import mx.core.UIComponent;
	import mx.core.UIComponentCachePolicy;
	import mx.core.UITextField;
	import mx.core.UITextFormat;
	import mx.core.mx_internal;
	import mx.effects.EffectManager;
	import mx.events.CloseEvent;
	import mx.events.SandboxMouseEvent;
	import mx.managers.ISystemManager;
	import mx.styles.ISimpleStyleClient;
	import mx.styles.IStyleClient;
	import mx.styles.StyleProxy;
	include "../styles/metadata/AlignStyles.as";
	include "../styles/metadata/GapStyles.as";
	include "../styles/metadata/ModalTransparencyStyles.as";
	public class Panel extends Container implements IConstraintLayout, IFontContextComponent {
		include "../core/Version.as";
		private static const HEADER_PADDING:Number=14;
		mx_internal static var createAccessibilityImplementation:Function;
		public function Panel();
		private var layoutObject:Layout;
		mx_internal var _showCloseButton:Boolean;
		mx_internal var titleBarBackground:IFlexDisplayObject;
		mx_internal var titleIconObject:Object;
		mx_internal var closeButton:Button;
		private var initializing:Boolean;
		private var panelViewMetrics:EdgeMetrics;
		private var regX:Number;
		private var regY:Number;
		private var checkedForAutoSetRoundedCorners:Boolean;
		private var autoSetRoundedCorners:Boolean;
		override public function get baselinePosition():Number;
		override public function set cacheAsBitmap(value:Boolean):void;
		override public function set enabled(value:Boolean):void;
		private static var _closeButtonStyleFilters:Object;
		protected function get closeButtonStyleFilters():Object;
		private var _constraintColumns:Array;
		public function get constraintColumns():Array;
		public function set constraintColumns(value:Array):void;
		private var _constraintRows:Array;
		public function get constraintRows():Array;
		public function set constraintRows(value:Array):void;
		protected var controlBar:IUIComponent;
		mx_internal function get _controlBar():IUIComponent;
		public function get fontContext():IFlexModuleFactory;
		public function set fontContext(moduleFactory:IFlexModuleFactory):void;
		private var _layout:String;
		public function get layout():String;
		public function set layout(value:String):void;
		private var _status:String;
		private var _statusChanged:Boolean;
		public function get status():String;
		public function set status(value:String):void;
		protected var statusTextField:IUITextField;
		private var _title:String;
		private var _titleChanged:Boolean;
		public function get title():String;
		public function set title(value:String):void;
		protected var titleBar:UIComponent;
		private var _titleIcon:Class;
		private var _titleIconChanged:Boolean;
		public function get titleIcon():Class;
		public function set titleIcon(value:Class):void;
		protected var titleTextField:IUITextField;
		override mx_internal function get usePadding():Boolean;
		override public function get viewMetrics():EdgeMetrics;
		override public function getChildIndex(child:DisplayObject):int;
		override protected function initializeAccessibility():void;
		override protected function createChildren():void;
		override protected function commitProperties():void;
		override protected function measure():void;
		override protected function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void;
		override public function styleChanged(styleProp:String):void;
		override protected function layoutChrome(unscaledWidth:Number,unscaledHeight:Number):void;
		override public function createComponentsFromDescriptors(recurse:Boolean=true):void;
		mx_internal function createTitleTextField(childIndex:int):void;
		mx_internal function removeTitleTextField():void;
		mx_internal function createStatusTextField(childIndex:int):void;
		mx_internal function removeStatusTextField():void;
		private function measureHeaderText():Rectangle;
		protected function getHeaderHeight():Number;
		mx_internal function getHeaderHeightProxy():Number;
		private function showTitleBar(show:Boolean):void;
		private function setControlBar(newControlBar:IUIComponent):void;
		protected function startDragging(event:MouseEvent):void;
		protected function stopDragging():void;
		mx_internal function getTitleBar():UIComponent;
		mx_internal function getTitleTextField():IUITextField;
		mx_internal function getStatusTextField():IUITextField;
		mx_internal function getControlBar():IUIComponent;
		private function titleBar_mouseDownHandler(event:MouseEvent):void;
		private function systemManager_mouseMoveHandler(event:MouseEvent):void;
		private function systemManager_mouseUpHandler(event:MouseEvent):void;
		private function stage_mouseLeaveHandler(event:Event):void;
		private function closeButton_clickHandler(event:MouseEvent):void;
	}
}
