package mx.controls {
	import flash.display.DisplayObject;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.text.TextLineMetrics;
	import flash.ui.Keyboard;
	import flash.utils.describeType;
	import flash.utils.getQualifiedClassName;
	import mx.core.IFlexDisplayObject;
	import mx.core.IFlexModuleFactory;
	import mx.core.IFontContextComponent;
	import mx.core.IUITextField;
	import mx.core.UIComponent;
	import mx.core.UITextField;
	import mx.core.mx_internal;
	import mx.events.CalendarLayoutChangeEvent;
	import mx.events.DateChooserEvent;
	import mx.events.DateChooserEventDetail;
	import mx.managers.IFocusManagerComponent;
	import mx.skins.halo.DateChooserIndicator;
	import mx.styles.ISimpleStyleClient;
	include "../styles/metadata/GapStyles.as";
	include "../styles/metadata/LeadingStyle.as";
	include "../styles/metadata/PaddingStyles.as";
	include "../styles/metadata/TextStyles.as";
	public class CalendarLayout extends UIComponent implements IFocusManagerComponent, IFontContextComponent {
		include "../core/Version.as";
		public function CalendarLayout();
		private var todayRow:int;
		private var todayColumn:int;
		private var enabledDaysInMonth:Array;
		private var disabledRangeMode:Array;
		private var cellHeight:Number;
		private var cellWidth:Number;
		private var yOffset:Number;
		mx_internal var dayBlocksArray:Array;
		private var disabledArrays:Array;
		private var todaysLabelReference:IUITextField;
		private var selectedMonthYearChanged:Boolean;
		private var todayIndicator:IFlexDisplayObject;
		private var selectionIndicator:Array;
		private var rollOverIndicator:IFlexDisplayObject;
		private var selectedRangeCount:int;
		private var lastSelectedDate:Date;
		private var rangeStartDate:Date;
		mx_internal var selRangeMode:int;
		private var _enabled:Boolean;
		private var enabledChanged:Boolean;
		override public function get enabled():Boolean;
		override public function set enabled(value:Boolean):void;
		private var _allowDisjointSelection:Boolean;
		public function get allowDisjointSelection():Boolean;
		public function set allowDisjointSelection(value:Boolean):void;
		private var _allowMultipleSelection:Boolean;
		public function get allowMultipleSelection():Boolean;
		public function set allowMultipleSelection(value:Boolean):void;
		private var _dayNames:Array;
		private var dayNamesChanged:Boolean;
		private var dayNamesOverride:Array;
		public function get dayNames():Array;
		public function set dayNames(value:Array):void;
		private var _disabledDays:Array;
		public function get disabledDays():Array;
		public function set disabledDays(value:Array):void;
		private var _disabledRanges:Array;
		public function get disabledRanges():Array;
		public function set disabledRanges(value:Array):void;
		private var _displayedMonth:int;
		private var _proposedDisplayedMonth:int;
		public function get displayedMonth():int;
		public function set displayedMonth(value:int):void;
		private var _displayedYear:int;
		private var _proposedDisplayedYear:int;
		public function get displayedYear():int;
		public function set displayedYear(value:int):void;
		private var _firstDayOfWeek:int;
		public function get firstDayOfWeek():int;
		public function set firstDayOfWeek(value:int):void;
		public function get fontContext():IFlexModuleFactory;
		public function set fontContext(moduleFactory:IFlexModuleFactory):void;
		private var _selectableRange:Object;
		public function get selectableRange():Object;
		public function set selectableRange(value:Object):void;
		private var _selectedRanges:Array;
		public function get selectedRanges():Array;
		public function set selectedRanges(value:Array):void;
		private var _showToday:Boolean;
		public function get showToday():Boolean;
		public function set showToday(value:Boolean):void;
		public function get selectedDate():Date;
		public function set selectedDate(value:Date):void;
		override protected function createChildren():void;
		override protected function commitProperties():void;
		override protected function measure():void;
		override protected function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void;
		override public function styleChanged(styleProp:String):void;
		override protected function resourcesChanged():void;
		mx_internal function createDayLabels(childIndex:int):void;
		mx_internal function removeDayLabels():void;
		mx_internal function createTodayIndicator(childIndex:int):void;
		mx_internal function removeTodayIndicator():void;
		mx_internal function drawDayNames():void;
		mx_internal function setSelectedMonthAndYear(monthVal:int=-1,yearVal:int=-1):void;
		mx_internal function getOffsetOfMonth(year:int,month:int):int;
		mx_internal function getNumberOfDaysInMonth(year:int,month:int):int;
		mx_internal function stepDate(deltaY:int,deltaM:int,triggerEvent:Event=null):void;
		static mx_internal function getNewIncrementDate(oldYear:int,oldMonth:int,deltaY:int,deltaM:int):Object;
		mx_internal function dispatchChangeEvent(triggerEvent:Event=null):void;
		mx_internal function isDateInRange(value:Date,dateRange:Object,rangeMode:int,ignoreDay:Boolean=false):Boolean;
		mx_internal function checkDateIsDisabled(value:Date):Boolean;
		mx_internal function addToSelected(newDate:Date,range:Boolean=false):void;
		mx_internal function incrementDate(value:Date,amount:int=1):Date;
		mx_internal function isSelected(newDate:Date):Boolean;
		mx_internal function removeRangeFromSelection(startDate:Date,endDate:Date):void;
		mx_internal function setSelectedIndicators():void;
		mx_internal function addSelectionIndicator(columnIndex:int,rowIndex:int):void;
		mx_internal function removeSelectionIndicator(columnIndex:int,rowIndex:int):void;
		mx_internal function removeSelectionIndicators():void;
		override protected function keyDownHandler(event:KeyboardEvent):void;
		private function mouseOverHandler(event:MouseEvent):void;
		private function mouseOutHandler(event:MouseEvent):void;
		private function mouseMoveHandler(event:MouseEvent):void;
		private function mouseUpHandler(event:MouseEvent):void;
		static private var dcis:Object;
		static private function isDateChooserIndicator(parent:Object):Boolean;
	}
}
