package mx.controls {
	import flash.display.DisplayObject;
	import flash.display.GradientType;
	import flash.display.Graphics;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.EventPhase;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.geom.Matrix;
	import flash.text.TextFormat;
	import flash.ui.Keyboard;
	import mx.core.FlexSprite;
	import mx.core.IFlexModuleFactory;
	import mx.core.IFontContextComponent;
	import mx.core.FlexVersion;
	import mx.core.IUITextField;
	import mx.core.UIComponent;
	import mx.core.UITextField;
	import mx.core.mx_internal;
	import mx.events.CalendarLayoutChangeEvent;
	import mx.events.DateChooserEvent;
	import mx.events.DateChooserEventDetail;
	import mx.events.FlexEvent;
	import mx.graphics.RectangularDropShadow;
	import mx.managers.IFocusManagerComponent;
	import mx.managers.ISystemManager;
	import mx.managers.SystemManager;
	import mx.resources.ResourceBundle;
	import mx.styles.StyleManager;
	import mx.utils.GraphicsUtil;
	import mx.styles.StyleProxy;
	include "../styles/metadata/FocusStyles.as";
	include "../styles/metadata/GapStyles.as";
	include "../styles/metadata/IconColorStyles.as";
	include "../styles/metadata/LeadingStyle.as";
	include "../styles/metadata/TextStyles.as";
	public class DateChooser extends UIComponent implements IFocusManagerComponent, IFontContextComponent {
		include "../core/Version.as";
		private var HEADER_WIDTH_PAD:Number;
		private var SKIN_WIDTH_PAD:Number;
		private var SKIN_HEIGHT_PAD:Number;
		private var YEAR_BUTTONS_PAD:Number;
		mx_internal static var createAccessibilityImplementation:Function;
		public function DateChooser();
		mx_internal var background:UIComponent;
		mx_internal var border:UIComponent;
		mx_internal var headerDisplay:UIComponent;
		mx_internal var monthDisplay:IUITextField;
		mx_internal var fwdMonthHit:Sprite;
		mx_internal var backMonthHit:Sprite;
		mx_internal var upYearHit:Sprite;
		mx_internal var downYearHit:Sprite;
		mx_internal var calHeader:UIComponent;
		mx_internal var yearDisplay:IUITextField;
		mx_internal var upYearButton:Button;
		mx_internal var downYearButton:Button;
		mx_internal var fwdMonthButton:Button;
		mx_internal var backMonthButton:Button;
		mx_internal var dateGrid:CalendarLayout;
		mx_internal var dropShadow:RectangularDropShadow;
		private var previousSelectedCellIndex:Number;
		private var monthSkinWidth:Number;
		private var monthSkinHeight:Number;
		private var yearSkinWidth:Number;
		private var yearSkinHeight:Number;
		private var headerHeight:Number;
		override public function get baselinePosition():Number;
		private var _enabled:Boolean;
		private var enabledChanged:Boolean;
		override public function get enabled():Boolean;
		override public function set enabled(value:Boolean):void;
		private var _allowDisjointSelection:Boolean;
		private var allowDisjointSelectionChanged:Boolean;
		public function get allowDisjointSelection():Boolean;
		public function set allowDisjointSelection(value:Boolean):void;
		private var _allowMultipleSelection:Boolean;
		private var allowMultipleSelectionChanged:Boolean;
		public function get allowMultipleSelection():Boolean;
		public function set allowMultipleSelection(value:Boolean):void;
		protected function get calendarLayoutStyleFilters():Object;
		private var _dayNames:Array;
		private var dayNamesChanged:Boolean;
		private var dayNamesOverride:Array;
		public function get dayNames():Array;
		public function set dayNames(value:Array):void;
		private var _disabledDays:Array;
		private var disabledDaysChanged:Boolean;
		public function get disabledDays():Array;
		public function set disabledDays(value:Array):void;
		private var _disabledRanges:Array;
		private var disabledRangesChanged:Boolean;
		public function get disabledRanges():Array;
		public function set disabledRanges(value:Array):void;
		private var _displayedMonth:int;
		private var displayedMonthChanged:Boolean;
		public function get displayedMonth():int;
		public function set displayedMonth(value:int):void;
		private var _displayedYear:int;
		private var displayedYearChanged:Boolean;
		public function get displayedYear():int;
		public function set displayedYear(value:int):void;
		private var _firstDayOfWeek:Object;
		private var firstDayOfWeekChanged:Boolean;
		private var firstDayOfWeekOverride:Object;
		public function get firstDayOfWeek():Object;
		public function set firstDayOfWeek(value:Object):void;
		public function get fontContext():IFlexModuleFactory;
		public function set fontContext(moduleFactory:IFlexModuleFactory):void;
		private var _maxYear:int;
		public function get maxYear():int;
		public function set maxYear(value:int):void;
		private var _minYear:int;
		public function get minYear():int;
		public function set minYear(value:int):void;
		private var _monthNames:Array;
		private var monthNamesChanged:Boolean;
		private var monthNamesOverride:Array;
		public function get monthNames():Array;
		public function set monthNames(value:Array):void;
		private var _monthSymbol:String;
		private var monthSymbolChanged:Boolean;
		private var monthSymbolOverride:String;
		public function get monthSymbol():String;
		public function set monthSymbol(value:String):void;
		protected function get nextMonthStyleFilters():Object;
		private static var _nextMonthStyleFilters:Object;
		protected function get nextYearStyleFilters():Object;
		private static var _nextYearStyleFilters:Object;
		protected function get prevMonthStyleFilters():Object;
		private static var _prevMonthStyleFilters:Object;
		protected function get prevYearStyleFilters():Object;
		private static var _prevYearStyleFilters:Object;
		private var _selectableRange:Object;
		private var selectableRangeChanged:Boolean;
		public function get selectableRange():Object;
		public function set selectableRange(value:Object):void;
		private var _selectedDate:Date;
		private var selectedDateChanged:Boolean;
		public function get selectedDate():Date;
		public function set selectedDate(value:Date):void;
		private var _selectedRanges:Array;
		private var selectedRangesChanged:Boolean;
		public function get selectedRanges():Array;
		public function set selectedRanges(value:Array):void;
		private var _showToday:Boolean;
		private var showTodayChanged:Boolean;
		public function get showToday():Boolean;
		public function set showToday(value:Boolean):void;
		private var _yearNavigationEnabled:Boolean;
		private var yearNavigationEnabledChanged:Boolean;
		public function get yearNavigationEnabled():Boolean;
		public function set yearNavigationEnabled(value:Boolean):void;
		private var _yearSymbol:String;
		private var yearSymbolChanged:Boolean;
		private var yearSymbolOverride:String;
		public function get yearSymbol():String;
		public function set yearSymbol(value:String):void;
		override protected function initializeAccessibility():void;
		override protected function createChildren():void;
		override protected function commitProperties():void;
		override protected function measure():void;
		override protected function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void;
		override public function styleChanged(styleProp:String):void;
		override protected function resourcesChanged():void;
		mx_internal function createMonthDisplay(childIndex:int):void;
		mx_internal function removeMonthDisplay():void;
		mx_internal function createYearDisplay(childIndex:int):void;
		mx_internal function removeYearDisplay():void;
		mx_internal function updateDateDisplay():void;
		private function getYearNavigationButtons():void;
		mx_internal function setMonthWidth():void;
		private function yearBeforeMonth(dateFormat:String):Boolean;
		mx_internal function scrubTimeValue(value:Object):Object;
		mx_internal function scrubTimeValues(values:Array):Array;
		override protected function keyDownHandler(event:KeyboardEvent):void;
		private function upYearButton_buttonDownHandler(event:Event):void;
		private function downYearButton_buttonDownHandler(event:Event):void;
		private function fwdMonthButton_buttonDownHandler(event:Event):void;
		private function backMonthButton_buttonDownHandler(event:Event):void;
		private function dateGrid_scrollHandler(event:DateChooserEvent):void;
		private function dateGrid_changeHandler(event:CalendarLayoutChangeEvent):void;
	}
}
