package mx.controls {
	import flash.display.DisplayObject;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.events.TextEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.ui.Keyboard;
	import mx.controls.dataGridClasses.DataGridListData;
	import mx.controls.listClasses.BaseListData;
	import mx.controls.listClasses.IDropInListItemRenderer;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.controls.listClasses.ListData;
	import mx.core.ClassFactory;
	import mx.core.FlexVersion;
	import mx.core.IDataRenderer;
	import mx.core.IFactory;
	import mx.core.mx_internal;
	import mx.core.UIComponentGlobals;
	import mx.events.CalendarLayoutChangeEvent;
	import mx.events.DateChooserEvent;
	import mx.events.DropdownEvent;
	import mx.events.FlexEvent;
	import mx.events.FlexMouseEvent;
	import mx.events.InterManagerRequest;
	import mx.events.SandboxMouseEvent;
	import mx.managers.IFocusManagerComponent;
	import mx.managers.ISystemManager;
	import mx.managers.PopUpManager;
	import mx.styles.CSSStyleDeclaration;
	import mx.styles.StyleManager;
	import mx.styles.StyleProxy;
	include "../styles/metadata/FocusStyles.as";
	include "../styles/metadata/IconColorStyles.as";
	include "../styles/metadata/LeadingStyle.as";
	include "../styles/metadata/PaddingStyles.as";
	include "../styles/metadata/TextStyles.as";
	public class DateField extends ComboBase implements IDataRenderer, IDropInListItemRenderer, IFocusManagerComponent, IListItemRenderer {
		include "../core/Version.as";
		mx_internal static var createAccessibilityImplementation:Function;
		public static function stringToDate(valueString:String,inputFormat:String):Date;
		public static function dateToString(value:Date,outputFormat:String):String;
		public function DateField();
		private var creatingDropdown:Boolean;
		mx_internal var showingDropdown:Boolean;
		private var inKeyDown:Boolean;
		private var isPressed:Boolean;
		private var openPos:Number;
		private var lastSelectedDate:Date;
		private var updateDateFiller:Boolean;
		private var addedToPopupManager:Boolean;
		private var isMouseOver:Boolean;
		private var yearChangedWithKeys:Boolean;
		private var selectedDateSet:Boolean;
		private var _enabled:Boolean;
		private var enabledChanged:Boolean;
		override public function get enabled():Boolean;
		override public function set enabled(value:Boolean):void;
		private var _data:Object;
		public function get data():Object;
		public function set data(value:Object):void;
		private var _dayNames:Array;
		private var dayNamesChanged:Boolean;
		private var dayNamesOverride:Array;
		public function get dayNames():Array;
		public function set dayNames(value:Array):void;
		private var _disabledDays:Array;
		private var disabledDaysChanged:Boolean;
		public function get disabledDays():Array;
		public function set disabledDays(value:Array):void;
		private var _disabledRanges:Array;
		private var disabledRangesChanged:Boolean;
		public function get disabledRanges():Array;
		public function set disabledRanges(value:Array):void;
		private var _displayedMonth:int;
		private var displayedMonthChanged:Boolean;
		public function get displayedMonth():int;
		public function set displayedMonth(value:int):void;
		private var _displayedYear:int;
		private var displayedYearChanged:Boolean;
		public function get displayedYear():int;
		public function set displayedYear(value:int):void;
		private var _dropdown:DateChooser;
		public function get dropdown():DateChooser;
		private var _dropdownFactory:IFactory;
		public function get dropdownFactory():IFactory;
		public function set dropdownFactory(value:IFactory):void;
		private var _firstDayOfWeek:Object;
		private var firstDayOfWeekChanged:Boolean;
		private var firstDayOfWeekOverride:Object;
		public function get firstDayOfWeek():Object;
		public function set firstDayOfWeek(value:Object):void;
		private var _formatString:String;
		private var formatStringOverride:String;
		public function get formatString():String;
		public function set formatString(value:String):void;
		private var _labelFunction:Function;
		public function get labelFunction():Function;
		public function set labelFunction(value:Function):void;
		private var _listData:BaseListData;
		public function get listData():BaseListData;
		public function set listData(value:BaseListData):void;
		private var _maxYear:int;
		private var maxYearChanged:Boolean;
		public function get maxYear():int;
		public function set maxYear(value:int):void;
		private var _minYear:int;
		private var minYearChanged:Boolean;
		public function get minYear():int;
		public function set minYear(value:int):void;
		private var _monthNames:Array;
		private var monthNamesChanged:Boolean;
		private var monthNamesOverride:Array;
		public function get monthNames():Array;
		public function set monthNames(value:Array):void;
		private var _monthSymbol:String;
		private var monthSymbolChanged:Boolean;
		private var monthSymbolOverride:String;
		public function get monthSymbol():String;
		public function set monthSymbol(value:String):void;
		private var _parseFunction:Function;
		public function get parseFunction():Function;
		public function set parseFunction(value:Function):void;
		private var _selectableRange:Object;
		private var selectableRangeChanged:Boolean;
		public function get selectableRange():Object;
		public function set selectableRange(value:Object):void;
		private var _selectedDate:Date;
		private var selectedDateChanged:Boolean;
		public function get selectedDate():Date;
		public function set selectedDate(value:Date):void;
		private var _showToday:Boolean;
		private var showTodayChanged:Boolean;
		public function get showToday():Boolean;
		public function set showToday(value:Boolean):void;
		private var _yearNavigationEnabled:Boolean;
		private var yearNavigationEnabledChanged:Boolean;
		public function get yearNavigationEnabled():Boolean;
		public function set yearNavigationEnabled(value:Boolean):void;
		private var _yearSymbol:String;
		private var yearSymbolChanged:Boolean;
		private var yearSymbolOverride:String;
		public function get yearSymbol():String;
		public function set yearSymbol(value:String):void;
		override protected function initializeAccessibility():void;
		override protected function createChildren():void;
		override protected function commitProperties():void;
		override protected function measure():void;
		override protected function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void;
		override public function styleChanged(styleProp:String):void;
		override public function notifyStyleChangeInChildren(styleProp:String,recursive:Boolean):void;
		override public function regenerateStyleCache(recursive:Boolean):void;
		override protected function resourcesChanged():void;
		public function open():void;
		public function close():void;
		private function displayDropdown(show:Boolean,triggerEvent:Event=null):void;
		private function createDropdown():void;
		private function dateFiller(value:Date):void;
		private function scrubTimeValue(value:Object):Object;
		private function scrubTimeValues(values:Array):Array;
		override protected function focusOutHandler(event:FocusEvent):void;
		override protected function keyDownHandler(event:KeyboardEvent):void;
		override protected function downArrowButton_buttonDownHandler(event:FlexEvent):void;
		override protected function textInput_changeHandler(event:Event):void;
		private function removedFromStageHandler(event:Event):void;
		private function dropdown_changeHandler(event:CalendarLayoutChangeEvent):void;
		private function dropdown_scrollHandler(event:DateChooserEvent):void;
		private function dropdown_mouseDownOutsideHandler(event:Event):void;
		private function selectedDate_changeHandler(triggerEvent:Event):void;
		private function textInput_textInputHandler(event:TextEvent):void;
		mx_internal function isShowingDropdown():Boolean;
	}
}
