package mx.controls {
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.ui.Keyboard;
	import flash.utils.clearInterval;
	import flash.utils.getTimer;
	import flash.utils.setTimeout;
	import flash.xml.XMLNode;
	import mx.collections.ArrayCollection;
	import mx.collections.CursorBookmark;
	import mx.collections.ICollectionView;
	import mx.collections.XMLListCollection;
	import mx.controls.listClasses.BaseListData;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.controls.menuClasses.IMenuBarItemRenderer;
	import mx.controls.menuClasses.IMenuDataDescriptor;
	import mx.controls.menuClasses.IMenuItemRenderer;
	import mx.controls.menuClasses.MenuItemRenderer;
	import mx.controls.menuClasses.MenuListData;
	import mx.controls.treeClasses.DefaultDataDescriptor;
	import mx.core.Application;
	import mx.core.ClassFactory;
	import mx.core.EdgeMetrics;
	import mx.core.EventPriority;
	import mx.core.ScrollPolicy;
	import mx.core.UIComponent;
	import mx.core.UIComponentGlobals;
	import mx.core.mx_internal;
	import mx.effects.Tween;
	import mx.events.CollectionEvent;
	import mx.events.CollectionEventKind;
	import mx.events.FlexEvent;
	import mx.events.FlexMouseEvent;
	import mx.events.InterManagerRequest;
	import mx.events.ListEvent;
	import mx.events.SandboxMouseEvent;
	import mx.events.MenuEvent;
	import mx.managers.IFocusManagerContainer;
	import mx.managers.ISystemManager;
	import mx.managers.PopUpManager;
	public class Menu extends List implements IFocusManagerContainer {
		include "../core/Version.as";
		mx_internal static var createAccessibilityImplementation:Function;
		public static function createMenu(parent:DisplayObjectContainer,mdp:Object,showRoot:Boolean=true):Menu;
		public static function popUpMenu(menu:Menu,parent:DisplayObjectContainer,mdp:Object):void;
		public function Menu();
		private var hiddenItem:IListItemRenderer;
		private var maxMeasuredIconWidth:Number;
		private var maxMeasuredTypeIconWidth:Number;
		private var maxMeasuredBranchIconWidth:Number;
		private var useTwoColumns:Boolean;
		mx_internal var sourceMenuBar:MenuBar;
		mx_internal var sourceMenuBarItem:IMenuBarItemRenderer;
		mx_internal var parentDisplayObject:DisplayObject;
		private var anchorRow:IListItemRenderer;
		private var subMenu:Menu;
		mx_internal var popupTween:Tween;
		mx_internal var supposedToLoseFocus:Boolean;
		mx_internal var openSubMenuTimer:int;
		mx_internal var closeTimer:int;
		mx_internal var _rootModel:ICollectionView;
		mx_internal var _parentMenu:Menu;
		public function get parentMenu():Menu;
		public function set parentMenu(value:Menu):void;
		mx_internal var _dataDescriptor:IMenuDataDescriptor;
		public function get dataDescriptor():IMenuDataDescriptor;
		public function set dataDescriptor(value:IMenuDataDescriptor):void;
		mx_internal var dataProviderChanged:Boolean;
		override public function set dataProvider(value:Object):void;
		override public function get dataProvider():Object;
		mx_internal var _showRoot:Boolean;
		mx_internal var showRootChanged:Boolean;
		public function get showRoot():Boolean;
		public function set showRoot(value:Boolean):void;
		mx_internal var _hasRoot:Boolean;
		public function get hasRoot():Boolean;
		private function parentHideHandler(event:FlexEvent):void;
		private function parentRowHeightHandler(event:Event):void;
		private function parentIconFieldHandler(event:Event):void;
		private function parentIconFunctionHandler(event:Event):void;
		private function parentLabelFieldHandler(event:Event):void;
		private function parentLabelFunctionHandler(event:Event):void;
		private function parentItemRendererHandler(event:Event):void;
		override public function get horizontalScrollPolicy():String;
		override public function set horizontalScrollPolicy(value:String):void;
		override public function get verticalScrollPolicy():String;
		override public function set verticalScrollPolicy(value:String):void;
		override protected function initializeAccessibility():void;
		override protected function commitProperties():void;
		override protected function measure():void;
		override public function measureWidthOfItems(index:int=-1,count:int=0):Number;
		override protected function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void;
		override public function styleChanged(styleProp:String):void;
		override protected function drawItem(item:IListItemRenderer,selected:Boolean=false,highlighted:Boolean=false,caret:Boolean=false,transition:Boolean=false):void;
		override protected function configureScrollBars():void;
		override mx_internal function clearHighlight(item:IListItemRenderer):void;
		override protected function mouseEventToItemRenderer(event:MouseEvent):IListItemRenderer;
		override public function setFocus():void;
		override protected function focusOutHandler(event:FocusEvent):void;
		override public function dispatchEvent(event:Event):Boolean;
		protected function setMenuItemToggled(item:Object,toggle:Boolean):void;
		override protected function makeListData(data:Object,uid:String,rowNum:int):BaseListData;
		public function show(xShow:Object=null,yShow:Object=null):void;
		mx_internal function onTweenUpdate(value:Object):void;
		mx_internal function onTweenEnd(value:Object):void;
		public function hide():void;
		override protected function collectionChangeHandler(event:Event):void;
		private function mouseDownOutsideHandler(event:Event):void;
		private static function menuHideHandler(event:MenuEvent):void;
		override protected function mouseUpHandler(event:MouseEvent):void;
		override protected function mouseDownHandler(event:MouseEvent):void;
		override protected function mouseOutHandler(event:MouseEvent):void;
		override protected function mouseOverHandler(event:MouseEvent):void;
		override protected function mouseClickHandler(event:MouseEvent):void;
		override protected function keyDownHandler(event:KeyboardEvent):void;
		private function moveSelBy(oldIndex:Number,incr:Number):void;
		mx_internal function openSubMenu(row:IListItemRenderer):void;
		private function closeSubMenu(menu:Menu):void;
		mx_internal function deleteDependentSubMenus():void;
		mx_internal function hideAllMenus():void;
		private function isMouseOverMenu(event:MouseEvent):Boolean;
		private function isMouseOverMenuBarItem(event:MouseEvent):Boolean;
		mx_internal function getRootMenu():Menu;
		private function getRowIndex(row:IListItemRenderer):int;
		mx_internal function get subMenus():Array;
	}
}
