package mx.controls.dataGridClasses {
	import flash.display.DisplayObject;
	import flash.display.Graphics;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.ui.Keyboard;
	import flash.utils.Dictionary;
	import flash.utils.setInterval;
	import mx.collections.CursorBookmark;
	import mx.collections.IViewCursor;
	import mx.collections.ItemResponder;
	import mx.collections.errors.ItemPendingError;
	import mx.controls.listClasses.BaseListData;
	import mx.controls.listClasses.IDropInListItemRenderer;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.controls.listClasses.ListBase;
	import mx.controls.listClasses.ListBaseContentHolder;
	import mx.controls.listClasses.ListBaseSeekPending;
	import mx.controls.listClasses.ListRowInfo;
	import mx.core.EdgeMetrics;
	import mx.core.IFactory;
	import mx.core.IFlexDisplayObject;
	import mx.core.IFlexModuleFactory;
	import mx.core.IFontContextComponent;
	import mx.core.IInvalidating;
	import mx.core.IUIComponent;
	import mx.core.IUITextField;
	import mx.core.mx_internal;
	import mx.core.SpriteAsset;
	import mx.core.UIComponentGlobals;
	import mx.core.UITextField;
	import mx.events.DragEvent;
	import mx.events.ListEvent;
	import mx.events.ScrollEvent;
	import mx.events.ScrollEventDetail;
	import mx.events.ScrollEventDirection;
	import mx.events.TweenEvent;
	import mx.skins.halo.ListDropIndicator;
	public class DataGridBase extends ListBase implements IFontContextComponent {
		include "../../core/Version.as";
		public function DataGridBase();
		protected var columnMap:Object;
		protected var freeItemRenderersTable:Dictionary;
		mx_internal var visibleColumns:Array;
		mx_internal var visibleLockedColumns:Array;
		protected var header:DataGridHeaderBase;
		mx_internal var headerClass:Class;
		protected var headerMask:Shape;
		protected var lockedColumnHeader:DataGridHeaderBase;
		private var lockedColumnHeaderMask:Shape;
		protected var lockedRowContent:DataGridLockedRowContentHolder;
		private var lockedRowMask:Shape;
		protected var lockedColumnAndRowContent:DataGridLockedRowContentHolder;
		private var lockedColumnAndRowMask:Shape;
		protected var lockedColumnContent:ListBaseContentHolder;
		private var lockedColumnMask:Shape;
		mx_internal function get dataGridHeader():DataGridHeaderBase;
		mx_internal function get dataGridLockedColumnHeader():DataGridHeaderBase;
		mx_internal function get dataGridLockedColumnAndRows():ListBaseContentHolder;
		mx_internal function get dataGridLockedRows():ListBaseContentHolder;
		mx_internal function get dataGridLockedColumns():ListBaseContentHolder;
		mx_internal var columnsInvalid:Boolean;
		mx_internal function columnRendererChanged(c:DataGridColumn):void;
		mx_internal function resizeColumn(col:int,w:Number):void;
		private var bShiftKey:Boolean;
		private var bCtrlKey:Boolean;
		private var lastKey:uint;
		private var bSelectItem:Boolean;
		private var inSelectItem:Boolean;
		public function get columns():Array;
		public function set columns(value:Array):void;
		public function get fontContext():IFlexModuleFactory;
		public function set fontContext(moduleFactory:IFlexModuleFactory):void;
		mx_internal var _headerHeight:Number;
		mx_internal var _explicitHeaderHeight:Boolean;
		public function get headerHeight():Number;
		public function set headerHeight(value:Number):void;
		private var lockedColumnCountChanged:Boolean;
		mx_internal var _lockedColumnCount:int;
		public function get lockedColumnCount():int;
		public function set lockedColumnCount(value:int):void;
		private var lockedRowCountChanged:Boolean;
		mx_internal var _lockedRowCount:int;
		public function get lockedRowCount():int;
		public function set lockedRowCount(value:int):void;
		private var _showHeaders:Boolean;
		public function get showHeaders():Boolean;
		public function set showHeaders(value:Boolean):void;
		mx_internal function get headerVisible():Boolean;
		override protected function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void;
		override protected function makeRowsAndColumns(left:Number,top:Number,right:Number,bottom:Number,firstCol:int,firstRow:int,byCount:Boolean=false,rowsNeeded:uint=0):Point;
		protected function makeRows(contentHolder:ListBaseContentHolder,left:Number,top:Number,right:Number,bottom:Number,firstCol:int,firstRow:int,byCount:Boolean=false,rowsNeeded:uint=0,alwaysCleanup:Boolean=false):Point;
		protected function prepareRowArray(contentHolder:ListBaseContentHolder,rowNum:int):void;
		protected function makeRow(contentHolder:ListBaseContentHolder,rowNum:int,left:Number,right:Number,yy:Number,data:Object,uid:String):Number;
		protected function clearRow(contentHolder:ListBaseContentHolder,rowNum:int):void;
		protected function adjustRow(contentHolder:ListBaseContentHolder,rowNum:int,yy:Number,hh:Number):void;
		protected function setRowInfo(contentHolder:ListBaseContentHolder,rowNum:int,yy:Number,hh:Number,uid:String):void;
		protected function removeExtraRow(contentHolder:ListBaseContentHolder):void;
		protected function setupColumnItemRenderer(c:DataGridColumn,contentHolder:ListBaseContentHolder,rowNum:int,colNum:int,data:Object,uid:String):IListItemRenderer;
		protected function layoutColumnItemRenderer(c:DataGridColumn,item:IListItemRenderer,xx:Number,yy:Number):Point;
		protected function drawVisibleItem(uid:String,selected:Boolean=false,highlighted:Boolean=false,caret:Boolean=false,transition:Boolean=false):void;
		override protected function drawItem(item:IListItemRenderer,selected:Boolean=false,highlighted:Boolean=false,caret:Boolean=false,transition:Boolean=false):void;
		protected function updateRendererDisplayList(r:IListItemRenderer):void;
		override protected function addToFreeItemRenderers(item:IListItemRenderer):void;
		override protected function purgeItemRenderers():void;
		override public function indicesToIndex(rowIndex:int,colIndex:int):int;
		protected function makeListData(data:Object,uid:String,rowNum:int,columnNum:int,column:DataGridColumn):BaseListData;
		mx_internal function getWidthOfItem(item:IListItemRenderer,col:DataGridColumn):Number;
		protected function calculateRowHeight(data:Object,hh:Number,skipVisible:Boolean=false):Number;
		public function createColumnItemRenderer(c:DataGridColumn,forHeader:Boolean,data:Object):IListItemRenderer;
		mx_internal function columnHeaderWordWrap(c:DataGridColumn):Boolean;
		mx_internal function columnWordWrap(c:DataGridColumn):Boolean;
		override protected function clearIndicators():void;
		protected var columnHighlightIndicator:Sprite;
		protected var columnCaretIndicator:Sprite;
		override protected function drawHighlightIndicator(indicator:Sprite,x:Number,y:Number,width:Number,height:Number,color:uint,itemRenderer:IListItemRenderer):void;
		override protected function clearHighlightIndicator(indicator:Sprite,itemRenderer:IListItemRenderer):void;
		override protected function drawCaretIndicator(indicator:Sprite,x:Number,y:Number,width:Number,height:Number,color:uint,itemRenderer:IListItemRenderer):void;
		override protected function clearCaretIndicator(indicator:Sprite,itemRenderer:IListItemRenderer):void;
		private var indicatorDictionary:Dictionary;
		override protected function drawSelectionIndicator(indicator:Sprite,x:Number,y:Number,width:Number,height:Number,color:uint,itemRenderer:IListItemRenderer):void;
		private function selectionRemovedListener(event:Event):void;
		override mx_internal function mouseEventToItemRendererOrEditor(event:MouseEvent):IListItemRenderer;
		mx_internal function getAllVisibleColumns():Array;
		override protected function UIDToItemRenderer(uid:String):IListItemRenderer;
		override mx_internal function addClipMask(layoutChanged:Boolean):void;
		mx_internal function get gridColumnMap():Object;
		override public function itemRendererToIndex(itemRenderer:IListItemRenderer):int;
		override mx_internal function selectionTween_updateHandler(event:TweenEvent):void;
		override protected function destroyRow(i:int,numCols:int):void;
		override protected function moveRowVertically(i:int,numCols:int,moveBlockDistance:Number):void;
		override protected function shiftRow(oldIndex:int,newIndex:int,numCols:int,shiftItems:Boolean):void;
		override protected function moveIndicatorsVertically(uid:String,moveBlockDistance:Number):void;
		override protected function truncateRowArrays(numRows:int):void;
		override protected function addToRowArrays():void;
		override protected function restoreRowArrays(modDeltaPos:int):void;
		override protected function removeFromRowArrays(i:int):void;
		override protected function clearVisibleData():void;
		override protected function set allowItemSizeChangeNotification(value:Boolean):void;
		override protected function indexToRow(index:int):int;
		override protected function moveSelectionVertically(code:uint,shiftKey:Boolean,ctrlKey:Boolean):void;
		override protected function finishKeySelection():void;
		override protected function itemRendererToIndices(item:IListItemRenderer):Point;
		override protected function selectItem(item:IListItemRenderer,shiftKey:Boolean,ctrlKey:Boolean,transition:Boolean=true):Boolean;
		override public function showDropFeedback(event:DragEvent):void;
		override protected function adjustAfterAdd(items:Array,location:int):Boolean;
		override protected function adjustAfterRemove(items:Array,location:int,requiresValueCommit:Boolean):Boolean;
	}
}
