package mx.core {
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.display.Graphics;
	import flash.display.InteractiveObject;
	import flash.display.Loader;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	import flash.text.TextLineMetrics;
	import flash.ui.Keyboard;
	import flash.utils.getDefinitionByName;
	import mx.binding.BindingManager;
	import mx.controls.Button;
	import mx.controls.HScrollBar;
	import mx.controls.VScrollBar;
	import mx.controls.listClasses.IListItemRenderer;
	import mx.controls.scrollClasses.ScrollBar;
	import mx.events.ChildExistenceChangedEvent;
	import mx.events.FlexEvent;
	import mx.events.IndexChangedEvent;
	import mx.events.ScrollEvent;
	import mx.events.ScrollEventDetail;
	import mx.events.ScrollEventDirection;
	import mx.graphics.RoundedRectangle;
	import mx.managers.IFocusManager;
	import mx.managers.IFocusManagerContainer;
	import mx.managers.ILayoutManagerClient;
	import mx.managers.ISystemManager;
	import mx.styles.CSSStyleDeclaration;
	import mx.styles.ISimpleStyleClient;
	import mx.styles.IStyleClient;
	import mx.styles.StyleManager;
	import mx.styles.StyleProtoChain;
	include "../styles/metadata/BarColorStyle.as";
	include "../styles/metadata/BorderStyles.as";
	include "../styles/metadata/PaddingStyles.as";
	include "../styles/metadata/TextStyles.as";
	public class Container extends UIComponent implements IContainer, IDataRenderer, IFocusManagerContainer, IListItemRenderer, IRawChildrenContainer {
		include "../core/Version.as";
		private static const MULTIPLE_PROPERTIES:String="<MULTIPLE>";
		public function Container();
		protected var actualCreationPolicy:String;
		private var numChildrenBefore:int;
		private var recursionFlag:Boolean;
		private var forceLayout:Boolean;
		mx_internal var doingLayout:Boolean;
		private var changedStyles:String;
		private var _creatingContentPane:Boolean;
		public function get creatingContentPane():Boolean;
		public function set creatingContentPane(value:Boolean):void;
		protected var whiteBox:Shape;
		mx_internal var contentPane:Sprite;
		private var scrollPropertiesChanged:Boolean;
		private var scrollPositionChanged:Boolean;
		private var horizontalScrollPositionPending:Number;
		private var verticalScrollPositionPending:Number;
		private var scrollableWidth:Number;
		private var scrollableHeight:Number;
		private var viewableWidth:Number;
		private var viewableHeight:Number;
		mx_internal var border:IFlexDisplayObject;
		mx_internal var blocker:Sprite;
		private var mouseEventReferenceCount:int;
		override public function get baselinePosition():Number;
		override public function get contentMouseX():Number;
		override public function get contentMouseY():Number;
		override public function set doubleClickEnabled(value:Boolean):void;
		override public function set enabled(value:Boolean):void;
		private var _focusPane:Sprite;
		override public function get focusPane():Sprite;
		override public function set focusPane(o:Sprite):void;
		mx_internal final function get $numChildren():int;
		mx_internal var _numChildren:int;
		override public function get numChildren():int;
		private var _autoLayout:Boolean;
		public function get autoLayout():Boolean;
		public function set autoLayout(value:Boolean):void;
		public function get borderMetrics():EdgeMetrics;
		private var _childDescriptors:Array;
		public function get childDescriptors():Array;
		private var _childRepeaters:Array;
		mx_internal function get childRepeaters():Array;
		mx_internal function set childRepeaters(value:Array):void;
		private var _clipContent:Boolean;
		public function get clipContent():Boolean;
		public function set clipContent(value:Boolean):void;
		private var _createdComponents:Array;
		mx_internal function get createdComponents():Array;
		mx_internal function set createdComponents(value:Array):void;
		private var _creationIndex:int;
		public function get creationIndex():int;
		public function set creationIndex(value:int):void;
		private var _creationPolicy:String;
		public function get creationPolicy():String;
		public function set creationPolicy(value:String):void;
		private var _defaultButton:IFlexDisplayObject;
		public function get defaultButton():IFlexDisplayObject;
		public function set defaultButton(value:IFlexDisplayObject):void;
		private var _data:Object;
		public function get data():Object;
		public function set data(value:Object):void;
		private var _firstChildIndex:int;
		mx_internal function get firstChildIndex():int;
		private var _horizontalLineScrollSize:Number;
		public function get horizontalLineScrollSize():Number;
		public function set horizontalLineScrollSize(value:Number):void;
		private var _horizontalPageScrollSize:Number;
		public function get horizontalPageScrollSize():Number;
		public function set horizontalPageScrollSize(value:Number):void;
		private var _horizontalScrollBar:ScrollBar;
		public function get horizontalScrollBar():ScrollBar;
		public function set horizontalScrollBar(value:ScrollBar):void;
		private var _horizontalScrollPosition:Number;
		public function get horizontalScrollPosition():Number;
		public function set horizontalScrollPosition(value:Number):void;
		mx_internal var _horizontalScrollPolicy:String;
		public function get horizontalScrollPolicy():String;
		public function set horizontalScrollPolicy(value:String):void;
		private var _icon:Class;
		public function get icon():Class;
		public function set icon(value:Class):void;
		private var _label:String;
		public function get label():String;
		public function set label(value:String):void;
		public function get maxHorizontalScrollPosition():Number;
		public function get maxVerticalScrollPosition():Number;
		private var _numChildrenCreated:int;
		mx_internal function get numChildrenCreated():int;
		mx_internal function set numChildrenCreated(value:int):void;
		mx_internal function get numRepeaters():int;
		private var _rawChildren:ContainerRawChildrenList;
		public function get rawChildren():IChildList;
		mx_internal function get usePadding():Boolean;
		private var _verticalLineScrollSize:Number;
		public function get verticalLineScrollSize():Number;
		public function set verticalLineScrollSize(value:Number):void;
		private var _verticalPageScrollSize:Number;
		public function get verticalPageScrollSize():Number;
		public function set verticalPageScrollSize(value:Number):void;
		private var _verticalScrollBar:ScrollBar;
		public function get verticalScrollBar():ScrollBar;
		public function set verticalScrollBar(value:ScrollBar):void;
		private var _verticalScrollPosition:Number;
		public function get verticalScrollPosition():Number;
		public function set verticalScrollPosition(value:Number):void;
		mx_internal var _verticalScrollPolicy:String;
		public function get verticalScrollPolicy():String;
		public function set verticalScrollPolicy(value:String):void;
		private var _viewMetrics:EdgeMetrics;
		public function get viewMetrics():EdgeMetrics;
		private var _viewMetricsAndPadding:EdgeMetrics;
		public function get viewMetricsAndPadding():EdgeMetrics;
		override public function addEventListener(type:String,listener:Function,useCapture:Boolean=false,priority:int=0,useWeakReference:Boolean=false):void;
		override public function removeEventListener(type:String,listener:Function,useCapture:Boolean=false):void;
		override public function addChild(child:DisplayObject):DisplayObject;
		override public function addChildAt(child:DisplayObject,index:int):DisplayObject;
		override public function removeChild(child:DisplayObject):DisplayObject;
		override public function removeChildAt(index:int):DisplayObject;
		override public function getChildAt(index:int):DisplayObject;
		override public function getChildByName(name:String):DisplayObject;
		override public function getChildIndex(child:DisplayObject):int;
		override public function setChildIndex(child:DisplayObject,newIndex:int):void;
		override public function contains(child:DisplayObject):Boolean;
		override public function initialize():void;
		override protected function createChildren():void;
		override protected function initializationComplete():void;
		override protected function commitProperties():void;
		override public function validateSize(recursive:Boolean=false):void;
		override public function validateDisplayList():void;
		override protected function updateDisplayList(unscaledWidth:Number,unscaledHeight:Number):void;
		override public function contentToGlobal(point:Point):Point;
		override public function globalToContent(point:Point):Point;
		override public function contentToLocal(point:Point):Point;
		override public function localToContent(point:Point):Point;
		override public function styleChanged(styleProp:String):void;
		override public function notifyStyleChangeInChildren(styleProp:String,recursive:Boolean):void;
		override public function regenerateStyleCache(recursive:Boolean):void;
		override protected function attachOverlay():void;
		override mx_internal function fillOverlay(overlay:UIComponent,color:uint,targetArea:RoundedRectangle=null):void;
		override public function executeBindings(recurse:Boolean=false):void;
		override public function prepareToPrint(target:IFlexDisplayObject):Object;
		override public function finishPrint(obj:Object,target:IFlexDisplayObject):void;
		override mx_internal function addingChild(child:DisplayObject):void;
		override mx_internal function childAdded(child:DisplayObject):void;
		override mx_internal function removingChild(child:DisplayObject):void;
		override mx_internal function childRemoved(child:DisplayObject):void;
		public function getChildren():Array;
		public function removeAllChildren():void;
		mx_internal function setDocumentDescriptor(desc:UIComponentDescriptor):void;
		mx_internal function setActualCreationPolicies(policy:String):void;
		public function createComponentsFromDescriptors(recurse:Boolean=true):void;
		public function createComponentFromDescriptor(descriptor:ComponentDescriptor,recurse:Boolean):IFlexDisplayObject;
		private function hasChildMatchingDescriptor(descriptor:UIComponentDescriptor):Boolean;
		mx_internal function rawChildren_addChild(child:DisplayObject):DisplayObject;
		mx_internal function rawChildren_addChildAt(child:DisplayObject,index:int):DisplayObject;
		mx_internal function rawChildren_removeChild(child:DisplayObject):DisplayObject;
		mx_internal function rawChildren_removeChildAt(index:int):DisplayObject;
		mx_internal function rawChildren_getChildAt(index:int):DisplayObject;
		mx_internal function rawChildren_getChildByName(name:String):DisplayObject;
		mx_internal function rawChildren_getChildIndex(child:DisplayObject):int;
		mx_internal function rawChildren_setChildIndex(child:DisplayObject,newIndex:int):void;
		mx_internal function rawChildren_getObjectsUnderPoint(pt:Point):Array;
		mx_internal function rawChildren_contains(child:DisplayObject):Boolean;
		protected function layoutChrome(unscaledWidth:Number,unscaledHeight:Number):void;
		protected function createBorder():void;
		private function isBorderNeeded():Boolean;
		mx_internal function invalidateViewMetricsAndPadding():void;
		private function createOrDestroyBlocker():void;
		private function updateBackgroundImageRect():void;
		private function createContentPaneAndScrollbarsIfNeeded():Boolean;
		mx_internal function getScrollableRect():Rectangle;
		private function createScrollbarsIfNeeded(bounds:Rectangle):Boolean;
		private function createOrDestroyScrollbars(needHorizontal:Boolean,needVertical:Boolean,needContentPane:Boolean):Boolean;
		private function clampScrollPositions():Boolean;
		mx_internal function createContentPane():void;
		protected function scrollChildren():void;
		private function dispatchScrollEvent(direction:String,oldPosition:Number,newPosition:Number,detail:String):void;
		private var _forceClippingCount:int;
		mx_internal function set forceClipping(value:Boolean):void;
		public function executeChildBindings(recurse:Boolean):void;
		override protected function keyDownHandler(event:KeyboardEvent):void;
		private function mouseWheelHandler(event:MouseEvent):void;
		private function layoutCompleteHandler(event:FlexEvent):void;
		private function creationCompleteHandler(event:FlexEvent):void;
		private function horizontalScrollBar_scrollHandler(event:Event):void;
		private function verticalScrollBar_scrollHandler(event:Event):void;
		private function blocker_clickHandler(event:Event):void;
	}
}
