package mx.managers {
	import flash.display.DisplayObject;
	import flash.display.DisplayObjectContainer;
	import flash.display.Graphics;
	import flash.display.InteractiveObject;
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.EventPhase;
	import flash.events.IEventDispatcher;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.net.getClassByAlias;
	import flash.net.registerClassAlias;
	import flash.system.ApplicationDomain;
	import flash.system.Capabilities;
	import flash.text.Font;
	import flash.text.TextFormat;
	import flash.utils.ByteArray;
	import flash.utils.Dictionary;
	import flash.utils.Timer;
	import flash.utils.getQualifiedClassName;
	import mx.core.EmbeddedFontRegistry;
	import mx.core.EventPriority;
	import mx.core.FlexSprite;
	import mx.core.ISWFLoader;
	import mx.core.IChildList;
	import mx.core.IFlexDisplayObject;
	import mx.core.IFlexModuleFactory;
	import mx.core.IInvalidating;
	import mx.core.IRawChildrenContainer;
	import mx.core.ISWFBridgeGroup;
	import mx.core.ISWFBridgeProvider;
	import mx.core.IUIComponent;
	import mx.core.RSLItem;
	import mx.core.Singleton;
	import mx.core.SWFBridgeGroup;
	import mx.core.TextFieldFactory;
	import mx.core.mx_internal;
	import mx.events.FlexEvent;
	import mx.messaging.config.LoaderConfig;
	import mx.preloaders.DownloadProgressBar;
	import mx.preloaders.Preloader;
	import mx.resources.IResourceManager;
	import mx.resources.ResourceBundle;
	import mx.resources.ResourceManager;
	import mx.styles.ISimpleStyleClient;
	import mx.styles.IStyleClient;
	import mx.styles.StyleManager;
	import mx.events.EventListenerRequest;
	import mx.events.FlexChangeEvent;
	import mx.events.InvalidateRequestData;
	import mx.events.InterManagerRequest;
	import mx.events.ResizeEvent;
	import mx.events.SandboxMouseEvent;
	import mx.events.SWFBridgeRequest;
	import mx.events.SWFBridgeEvent;
	import mx.managers.systemClasses.RemotePopUp;
	import mx.managers.systemClasses.EventProxy;
	import mx.managers.systemClasses.StageEventProxy;
	import mx.managers.systemClasses.PlaceholderData;
	import mx.utils.EventUtil;
	import mx.utils.NameUtil;
	import mx.utils.LoaderUtil;
	import mx.utils.ObjectUtil;
	import mx.utils.SecurityUtil;
	public class SystemManager extends MovieClip implements IChildList, IFlexDisplayObject, IFlexModuleFactory, ISystemManager, ISWFBridgeProvider {
		include "../core/Version.as";
		private static const IDLE_THRESHOLD:Number=1000;
		private static const IDLE_INTERVAL:Number=100;
		mx_internal static var allSystemManagers:Dictionary;
		mx_internal static var lastSystemManager:SystemManager;
		mx_internal static function registerInitCallback(initFunction:Function):void;
		public function SystemManager();
		private function deferredNextFrame():void;
		private var doneExecutingInitCallbacks:Boolean;
		private var initCallbackFunctions:Array;
		private var initialized:Boolean;
		mx_internal var topLevel:Boolean;
		private var isStageRoot:Boolean;
		private var isBootstrapRoot:Boolean;
		private var _topLevelSystemManager:ISystemManager;
		private var _stage:Stage;
		mx_internal var nestLevel:int;
		private var rslSizes:Array;
		private var preloader:Preloader;
		private var mouseCatcher:Sprite;
		mx_internal var topLevelWindow:IUIComponent;
		private var forms:Array;
		private var form:Object;
		mx_internal var idleCounter:int;
		private var idleTimer:Timer;
		private var nextFrameTimer:Timer;
		private var lastFrame:int;
		private var _height:Number;
		override public function get height():Number;
		override public function get stage():Stage;
		private var _width:Number;
		override public function get width():Number;
		override public function get numChildren():int;
		public function get application():IUIComponent;
		private var _applicationIndex:int;
		mx_internal function get applicationIndex():int;
		mx_internal function set applicationIndex(value:int):void;
		private var _bridgeToFocusManager:Dictionary;
		mx_internal function get bridgeToFocusManager():Dictionary;
		mx_internal function set bridgeToFocusManager(bridgeToFMDictionary:Dictionary):void;
		private var _cursorChildren:SystemChildrenList;
		public function get cursorChildren():IChildList;
		private var _cursorIndex:int;
		mx_internal function get cursorIndex():int;
		mx_internal function set cursorIndex(value:int):void;
		private var _document:Object;
		public function get document():Object;
		public function set document(value:Object):void;
		private var _fontList:Object;
		public function get embeddedFontList():Object;
		private var _explicitHeight:Number;
		public function get explicitHeight():Number;
		public function set explicitHeight(value:Number):void;
		private var _explicitWidth:Number;
		public function get explicitWidth():Number;
		public function set explicitWidth(value:Number):void;
		private var _focusPane:Sprite;
		public function get focusPane():Sprite;
		public function set focusPane(value:Sprite):void;
		public function info():Object;
		public function get measuredHeight():Number;
		public function get measuredWidth():Number;
		private var _noTopMostIndex:int;
		mx_internal function get noTopMostIndex():int;
		mx_internal function set noTopMostIndex(value:int):void;
		mx_internal final function get $numChildren():int;
		private var _numModalWindows:int;
		public function get numModalWindows():int;
		public function set numModalWindows(value:int):void;
		public function get preloaderBackgroundAlpha():Number;
		public function get preloaderBackgroundColor():uint;
		public function get preloaderBackgroundImage():Object;
		public function get preloaderBackgroundSize():String;
		private var _popUpChildren:SystemChildrenList;
		public function get popUpChildren():IChildList;
		private var _rawChildren:SystemRawChildrenList;
		public function get rawChildren():IChildList;
		private var _swfBridgeGroup:ISWFBridgeGroup;
		public function get swfBridgeGroup():ISWFBridgeGroup;
		public function set swfBridgeGroup(bridgeGroup:ISWFBridgeGroup):void;
		private var _screen:Rectangle;
		public function get screen():Rectangle;
		private var _toolTipChildren:SystemChildrenList;
		public function get toolTipChildren():IChildList;
		private var _toolTipIndex:int;
		mx_internal function get toolTipIndex():int;
		mx_internal function set toolTipIndex(value:int):void;
		public function get topLevelSystemManager():ISystemManager;
		private var _topMostIndex:int;
		mx_internal function get topMostIndex():int;
		mx_internal function set topMostIndex(value:int):void;
		public function get swfBridge():IEventDispatcher;
		public function get childAllowsParent():Boolean;
		public function get parentAllowsChild():Boolean;
		private var isDispatchingResizeEvent:Boolean;
		private var idToPlaceholder:Object;
		private var eventProxy:EventProxy;
		private var weakReferenceProxies:Dictionary;
		private var strongReferenceProxies:Dictionary;
		override public function addEventListener(type:String,listener:Function,useCapture:Boolean=false,priority:int=0,useWeakReference:Boolean=false):void;
		private function hasSWFBridges():Boolean;
		override public function removeEventListener(type:String,listener:Function,useCapture:Boolean=false):void;
		override public function addChild(child:DisplayObject):DisplayObject;
		override public function addChildAt(child:DisplayObject,index:int):DisplayObject;
		mx_internal final function $addChildAt(child:DisplayObject,index:int):DisplayObject;
		mx_internal final function $removeChildAt(index:int):DisplayObject;
		override public function removeChild(child:DisplayObject):DisplayObject;
		override public function removeChildAt(index:int):DisplayObject;
		override public function getChildAt(index:int):DisplayObject;
		override public function getChildByName(name:String):DisplayObject;
		override public function getChildIndex(child:DisplayObject):int;
		override public function setChildIndex(child:DisplayObject,newIndex:int):void;
		override public function getObjectsUnderPoint(point:Point):Array;
		override public function contains(child:DisplayObject):Boolean;
		public function create(...params):Object;
		mx_internal function initialize():void;
		private function executeCallbacks():void;
		mx_internal function addingChild(child:DisplayObject):void;
		mx_internal function childAdded(child:DisplayObject):void;
		mx_internal function removingChild(child:DisplayObject):void;
		mx_internal function childRemoved(child:DisplayObject):void;
		mx_internal function rawChildren_addChild(child:DisplayObject):DisplayObject;
		mx_internal function rawChildren_addChildAt(child:DisplayObject,index:int):DisplayObject;
		mx_internal function rawChildren_removeChild(child:DisplayObject):DisplayObject;
		mx_internal function rawChildren_removeChildAt(index:int):DisplayObject;
		mx_internal function rawChildren_getChildAt(index:int):DisplayObject;
		mx_internal function rawChildren_getChildByName(name:String):DisplayObject;
		mx_internal function rawChildren_getChildIndex(child:DisplayObject):int;
		mx_internal function rawChildren_setChildIndex(child:DisplayObject,newIndex:int):void;
		mx_internal function rawChildren_getObjectsUnderPoint(pt:Point):Array;
		mx_internal function rawChildren_contains(child:DisplayObject):Boolean;
		public function getExplicitOrMeasuredWidth():Number;
		public function getExplicitOrMeasuredHeight():Number;
		public function move(x:Number,y:Number):void;
		public function setActualSize(newWidth:Number,newHeight:Number):void;
		mx_internal function regenerateStyleCache(recursive:Boolean):void;
		mx_internal function notifyStyleChangeInChildren(styleProp:String,recursive:Boolean):void;
		public function activate(f:IFocusManagerContainer):void;
		private function activateForm(f:Object):void;
		public function deactivate(f:IFocusManagerContainer):void;
		private function deactivateForm(f:Object):void;
		private function findLastActiveForm(f:Object):Object;
		private function canActivatePopUp(f:Object):Boolean;
		private function canActivateLocalComponent(o:Object):Boolean;
		private static function isRemotePopUp(form:Object):Boolean;
		private static function areRemotePopUpsEqual(form1:Object,form2:Object):Boolean;
		private function findRemotePopUp(window:Object,bridge:IEventDispatcher):RemotePopUp;
		private function removeRemotePopUp(form:RemotePopUp):void;
		private function activateRemotePopUp(form:Object):void;
		private function deactivateRemotePopUp(form:Object):void;
		private function areFormsEqual(form1:Object,form2:Object):Boolean;
		public function addFocusManager(f:IFocusManagerContainer):void;
		public function removeFocusManager(f:IFocusManagerContainer):void;
		public function getDefinitionByName(name:String):Object;
		public static function getSWFRoot(object:Object):DisplayObject;
		public function isTopLevel():Boolean;
		public function isTopLevelRoot():Boolean;
		public function isTopLevelWindow(object:DisplayObject):Boolean;
		public function isFontFaceEmbedded(textFormat:TextFormat):Boolean;
		private function dispatchInvalidateRequest():void;
		private function resizeMouseCatcher():void;
		private function initHandler(event:Event):void;
		private function docFrameListener(event:Event):void;
		private function extraFrameListener(event:Event):void;
		private function preloader_initProgressHandler(event:Event):void;
		private function preloader_preloaderDoneHandler(event:Event):void;
		mx_internal function docFrameHandler(event:Event=null):void;
		private function installCompiledResourceBundles():void;
		private function extraFrameHandler(event:Event=null):void;
		private function nextFrameTimerHandler(event:TimerEvent):void;
		private function initializeTopLevelWindow(event:Event):void;
		private function appCreationCompleteHandler(event:FlexEvent):void;
		private function Stage_resizeHandler(event:Event=null):void;
		private function mouseDownHandler(event:MouseEvent):void;
		private static function getChildListIndex(childList:IChildList,f:Object):int;
		private function mouseMoveHandler(event:MouseEvent):void;
		private function mouseUpHandler(event:MouseEvent):void;
		private function idleTimer_timerHandler(event:TimerEvent):void;
		private function beforeUnloadHandler(event:Event):void;
		private function unloadHandler(event:Event):void;
		private function addPopupRequestHandler(event:Event):void;
		private function removePopupRequestHandler(event:Event):void;
		private function addPlaceholderPopupRequestHandler(event:Event):void;
		private function removePlaceholderPopupRequestHandler(event:Event):void;
		private function forwardFormEvent(event:SWFBridgeEvent):Boolean;
		private function forwardPlaceholderRequest(request:SWFBridgeRequest,addPlaceholder:Boolean):Boolean;
		private function deactivateFormSandboxEventHandler(event:Event):void;
		private function activateFormSandboxEventHandler(event:Event):void;
		private function activateApplicationSandboxEventHandler(event:Event):void;
		private function modalWindowRequestHandler(event:Event):void;
		private function getVisibleRectRequestHandler(event:Event):void;
		private function hideMouseCursorRequestHandler(event:Event):void;
		private function showMouseCursorRequestHandler(event:Event):void;
		private function resetMouseCursorRequestHandler(event:Event):void;
		private function resetMouseCursorTracking(event:Event):void;
		private function setActualSizeRequestHandler(event:Event):void;
		private function getSizeRequestHandler(event:Event):void;
		private function activateRequestHandler(event:Event):void;
		private function deactivateRequestHandler(event:Event):void;
		private function isBridgeChildHandler(event:Event):void;
		private function canActivateHandler(event:Event):void;
		public function isDisplayObjectInABridgedApplication(displayObject:DisplayObject):Boolean;
		private function getSWFBridgeOfDisplayObject(displayObject:DisplayObject):IEventDispatcher;
		private function multiWindowRedispatcher(event:Event):void;
		private function initManagerHandler(event:Event):void;
		public function addChildToSandboxRoot(layer:String,child:DisplayObject):void;
		public function removeChildFromSandboxRoot(layer:String,child:DisplayObject):void;
		private function systemManagerHandler(event:Event):void;
		mx_internal var _mouseX:*;
		mx_internal var _mouseY:*;
		override public function get mouseX():Number;
		override public function get mouseY():Number;
		private function getSandboxScreen():Rectangle;
		mx_internal function findFocusManagerContainer(smp:SystemManagerProxy):IFocusManagerContainer;
		mx_internal function addChildBridgeListeners(bridge:IEventDispatcher):void;
		mx_internal function removeChildBridgeListeners(bridge:IEventDispatcher):void;
		mx_internal function addParentBridgeListeners():void;
		mx_internal function removeParentBridgeListeners():void;
		private function getTopLevelSystemManager(parent:DisplayObject):ISystemManager;
		override public function get parent():DisplayObjectContainer;
		public function addChildBridge(bridge:IEventDispatcher,owner:DisplayObject):void;
		public function removeChildBridge(bridge:IEventDispatcher):void;
		public function useSWFBridge():Boolean;
		public function getTopLevelRoot():DisplayObject;
		public function getSandboxRoot():DisplayObject;
		public function getVisibleApplicationRect(bounds:Rectangle=null):Rectangle;
		public function deployMouseShields(deploy:Boolean):void;
		mx_internal function dispatchActivatedWindowEvent(window:DisplayObject):void;
		private function dispatchDeactivatedWindowEvent(window:DisplayObject):void;
		private function dispatchActivatedApplicationEvent():void;
		private function updateLastActiveForm():void;
		private function addPlaceholderId(id:String,previousId:String,bridge:IEventDispatcher,placeholder:Object):void;
		private function removePlaceholderId(id:String):void;
		private var currentSandboxEvent:Event;
		private var dispatchingToSystemManagers:Boolean;
		private function dispatchEventToOtherSystemManagers(event:Event):void;
		public function dispatchEventFromSWFBridges(event:Event,skip:IEventDispatcher=null,trackClones:Boolean=false,toOtherSystemManagers:Boolean=false):void;
		private function addEventListenerToSandboxes(type:String,listener:Function,useCapture:Boolean=false,priority:int=0,useWeakReference:Boolean=false,skip:IEventDispatcher=null):void;
		private function removeEventListenerFromSandboxes(type:String,listener:Function,useCapture:Boolean=false,skip:IEventDispatcher=null):void;
		private function addEventListenerToOtherSystemManagers(type:String,listener:Function,useCapture:Boolean=false,priority:int=0,useWeakReference:Boolean=false):void;
		private function removeEventListenerFromOtherSystemManagers(type:String,listener:Function,useCapture:Boolean=false):void;
		private function preProcessModalWindowRequest(request:SWFBridgeRequest,sbRoot:DisplayObject):Boolean;
		private function otherSystemManagerMouseListener(event:SandboxMouseEvent):void;
		private function sandboxMouseListener(event:Event):void;
		private function eventListenerRequestHandler(event:Event):void;
	}
}
