package mx.messaging {
	import flash.display.DisplayObject;
	import flash.errors.IllegalOperationError;
	import flash.events.StatusEvent;
	import mx.core.mx_internal;
	import mx.collections.ArrayCollection;
	import mx.collections.ListCollectionView;
	import mx.events.PropertyChangeEvent;
	import mx.messaging.messages.IMessage;
	import mx.rpc.AsyncDispatcher;
	import mx.rpc.AsyncToken;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.Fault;
	public class AbstractMessageStore extends ArrayCollection {
		public function AbstractMessageStore();
		private var _autoSend:Boolean;
		public function get autoSend():Boolean;
		public function set autoSend(value:Boolean):void;
		private var _cacheId:String;
		public function get cacheID():String;
		public function set cacheID(value:String):void;
		protected var _initialized:Boolean;
		public function get isInitialized():Boolean;
		private var _loaded:Boolean;
		public function get loaded():Boolean;
		private var _producer:AbstractProducer;
		public function get producer():AbstractProducer;
		override public function addItem(item:Object):void;
		public function clearCache():AsyncToken;
		public function getCacheIDs(view:ListCollectionView):AsyncToken;
		public function initialize():AsyncToken;
		public function loadCache():AsyncToken;
		public function release():AsyncToken;
		public function saveCache():AsyncToken;
		mx_internal function addMessage(msg:IMessage):void;
		mx_internal function removeMessage(msg:IMessage):void;
		mx_internal function setProducer(value:AbstractProducer):void;
		protected function attemptToSendOrConnect():void;
		protected function dispatchFaultEvent(fault:Fault,token:AsyncToken):void;
		protected function dispatchResultEvent(event:ResultEvent,token:AsyncToken):void;
		protected function internalClearCache(token:AsyncToken):void;
		protected function internalGetCacheIDs(view:ListCollectionView,token:AsyncToken):void;
		protected function internalInitialize(success:Function,failed:Function):void;
		protected function internalLoadCache(token:AsyncToken):void;
		protected function internalRelease(token:AsyncToken):void;
		protected function internalSetCacheId(value:String):void;
		protected function internalSaveCache(token:AsyncToken):void;
		protected function send(msg:IMessage):void;
		protected function sendAll():void;
		protected function setLoaded(value:Boolean):void;
		private function checkCacheId():void;
		private function getInitFailedFault(details:String=null):Fault;
		private function producerPropertyChangeHandler(event:PropertyChangeEvent):void;
		public static const MESSAGE_STORE_HEADER:String="DSMessageStore";
	}
}
