package mx.messaging {
	import flash.errors.IllegalOperationError;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import mx.core.mx_internal;
	import mx.events.PropertyChangeEvent;
	import mx.logging.Log;
	import mx.messaging.config.ConfigMap;
	import mx.messaging.config.ServerConfig;
	import mx.messaging.errors.InvalidDestinationError;
	import mx.messaging.errors.MessagingError;
	import mx.messaging.events.ChannelEvent;
	import mx.messaging.events.ChannelFaultEvent;
	import mx.messaging.events.MessageAckEvent;
	import mx.messaging.events.MessageEvent;
	import mx.messaging.events.MessageFaultEvent;
	import mx.messaging.messages.AbstractMessage;
	import mx.messaging.messages.AcknowledgeMessage;
	import mx.messaging.messages.AsyncMessage;
	import mx.messaging.messages.CommandMessage;
	import mx.messaging.messages.ErrorMessage;
	import mx.messaging.messages.IMessage;
	import mx.resources.IResourceManager;
	import mx.resources.ResourceManager;
	public class AbstractProducer extends MessageAgent {
		public function AbstractProducer();
		private var _connectMsg:CommandMessage;
		private var _currentAttempt:int;
		private var _reconnectTimer:Timer;
		protected var _shouldBeConnected:Boolean;
		private var resourceManager:IResourceManager;
		private var _autoConnect:Boolean;
		public function get autoConnect():Boolean;
		public function set autoConnect(value:Boolean):void;
		private var _defaultHeaders:Object;
		public function get defaultHeaders():Object;
		public function set defaultHeaders(value:Object):void;
		private var _reconnectAttempts:int;
		public function get reconnectAttempts():int;
		public function set reconnectAttempts(value:int):void;
		private var _reconnectInterval:int;
		public function get reconnectInterval():int;
		public function set reconnectInterval(value:int):void;
		override public function acknowledge(ackMsg:AcknowledgeMessage,msg:IMessage):void;
		override public function fault(errMsg:ErrorMessage,msg:IMessage):void;
		override public function channelDisconnectHandler(event:ChannelEvent):void;
		override public function channelFaultHandler(event:ChannelFaultEvent):void;
		override public function disconnect():void;
		public function connect():void;
		public function send(message:IMessage):void;
		mx_internal function internalFault(errMsg:ErrorMessage,msg:IMessage,routeToStore:Boolean=true,ignoreDisconnectBarrier:Boolean=false):void;
		protected function reconnect(event:TimerEvent):void;
		protected function startReconnectTimer():void;
		protected function stopReconnectTimer():void;
		private function buildConnectErrorMessage():ErrorMessage;
		private function buildConnectMessage():CommandMessage;
	}
}
