	package mx.messaging {
		import flash.errors.IllegalOperationError;
		import flash.events.EventDispatcher;
		import flash.events.TimerEvent;
		import flash.utils.Timer;
		import mx.collections.ArrayCollection;
		import mx.core.IMXMLObject;
		import mx.core.mx_internal;
		import mx.events.PropertyChangeEvent;
		import mx.logging.ILogger;
		import mx.logging.Log;
		import mx.messaging.config.LoaderConfig;
		import mx.messaging.config.ServerConfig;
		import mx.messaging.errors.InvalidChannelError;
		import mx.messaging.errors.InvalidDestinationError;
		import mx.messaging.events.ChannelEvent;
		import mx.messaging.events.ChannelFaultEvent;
		import mx.messaging.messages.AbstractMessage;
		import mx.messaging.messages.CommandMessage;
		import mx.messaging.messages.IMessage;
		import mx.resources.IResourceManager;
		import mx.resources.ResourceManager;
		import mx.utils.URLUtil;
		public class Channel extends EventDispatcher implements IMXMLObject {
			public function Channel(id:String=null,uri:String=null);
			public function initialized(document:Object,id:String):void;
			mx_internal var authenticating:Boolean;
			protected var credentials:String;
			public var enableSmallMessages:Boolean;
			protected var _log:ILogger;
			protected var _connecting:Boolean;
			private var _connectTimer:Timer;
			private var _failoverIndex:int;
			private var _isEndpointCalculated:Boolean;
			protected var messagingVersion:Number;
			private var _ownsWaitGuard:Boolean;
			private var _primaryURI:String;
			private var resourceManager:IResourceManager;
			private var _shouldBeConnected:Boolean;
			private var _channelSets:Array;
			public function get channelSets():Array;
			private var _connected:Boolean;
			public function get connected():Boolean;
			protected function setConnected(value:Boolean):void;
			private var _connectTimeout:int;
			public function get connectTimeout():int;
			public function set connectTimeout(value:int):void;
			private var _endpoint:String;
			public function get endpoint():String;
			protected var _loginAfterDisconnect:Boolean;
			mx_internal function get loginAfterDisconnect():Boolean;
			protected var _recordMessageTimes:Boolean;
			public function get recordMessageTimes():Boolean;
			protected var _recordMessageSizes:Boolean;
			public function get recordMessageSizes():Boolean;
			private var _reconnecting:Boolean;
			public function get reconnecting():Boolean;
			private function setReconnecting(value:Boolean):void;
			private var _failoverURIs:Array;
			public function get failoverURIs():Array;
			public function set failoverURIs(value:Array):void;
			private var _id:String;
			public function get id():String;
			public function set id(value:String):void;
			private var _authenticated:Boolean;
			public function get authenticated():Boolean;
			mx_internal function setAuthenticated(value:Boolean):void;
			public function get protocol():String;
			mx_internal function get realtime():Boolean;
			private var _requestTimeout:int;
			public function get requestTimeout():int;
			public function set requestTimeout(value:int):void;
			private var _uri:String;
			public function get uri():String;
			public function set uri(value:String):void;
			public function get url():String;
			public function set url(value:String):void;
			private var _smallMessagesSupported:Boolean;
			public function get useSmallMessages():Boolean;
			public function set useSmallMessages(value:Boolean):void;
			public function applySettings(settings:XML):void;
			final public function connect(channelSet:ChannelSet):void;
			final public function disconnect(channelSet:ChannelSet):void;
			public function logout(agent:MessageAgent):void;
			public function send(agent:MessageAgent,message:IMessage):void;
			public function setCredentials(credentials:String,agent:MessageAgent=null,charset:String=null):void;
			public function get mpiEnabled():Boolean;
			mx_internal function internalSetCredentials(credentials:String):void;
			mx_internal function sendClusterRequest(msgResp:MessageResponder):void;
			protected function connectFailed(event:ChannelFaultEvent):void;
			protected function connectSuccess():void;
			protected function connectTimeoutHandler(event:TimerEvent):void;
			protected function disconnectSuccess(rejected:Boolean=false):void;
			protected function disconnectFailed(event:ChannelFaultEvent):void;
			protected function flexClientWaitHandler(event:PropertyChangeEvent):void;
			protected function getMessageResponder(agent:MessageAgent,message:IMessage):MessageResponder;
			protected function internalConnect():void;
			protected function internalDisconnect(rejected:Boolean=false):void;
			protected function internalSend(messageResponder:MessageResponder):void;
			protected function handleServerMessagingVersion(version:Number):void;
			protected function setFlexClientIdOnMessage(message:IMessage):void;
			private function calculateEndpoint():void;
			private function initializeRequestTimeout(messageResponder:MessageResponder):void;
			private function shouldAttemptFailover():Boolean;
			private function failover():void;
			private function reconnect(event:TimerEvent):void;
			private function resetToPrimaryURI():void;
			private function shutdownConnectTimer():void;
			public static const SMALL_MESSAGES_FEATURE:String="small_messages";
			private static const dep:ArrayCollection=null;
		}
	}
	import mx.core.mx_internal;
	import mx.logging.ILogger;
	import mx.logging.Log;
	import mx.messaging.Channel;
	import mx.messaging.MessageAgent;
	import mx.messaging.MessageResponder;
	import mx.messaging.events.ChannelEvent;
	import mx.messaging.events.ChannelFaultEvent;
	import mx.messaging.messages.CommandMessage;
	import mx.messaging.messages.ErrorMessage;
	import mx.messaging.messages.IMessage;
	import mx.events.PropertyChangeEvent;
	class AuthenticationMessageResponder extends MessageResponder {
		public function AuthenticationMessageResponder(agent:MessageAgent,message:IMessage,channel:Channel,log:ILogger);
		private var _log:ILogger;
		override protected function resultHandler(msg:IMessage):void;
		override protected function statusHandler(msg:IMessage):void;
	}
