package mx.messaging.channels {
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.HTTPStatusEvent;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.events.SecurityErrorEvent;
	import flash.events.StatusEvent;
	import flash.net.ObjectEncoding;
	import flash.net.URLRequest;
	import flash.net.URLRequestMethod;
	import flash.net.URLStream;
	import flash.net.URLVariables;
	import flash.utils.ByteArray;
	import mx.core.mx_internal;
	import mx.logging.ILogger;
	import mx.messaging.Channel;
	import mx.messaging.FlexClient;
	import mx.messaging.events.MessageEvent;
	import mx.messaging.messages.AbstractMessage;
	import mx.messaging.messages.AcknowledgeMessage;
	import mx.messaging.messages.CommandMessage;
	import mx.messaging.messages.IMessage;
	public class StreamingConnectionHandler extends EventDispatcher {
		public static const DISCONNECT_CODE:String="disconnect";
		private static const COMMAND_PARAM_NAME:String="command";
		private static const OPEN_COMMAND:String="open";
		private static const CLOSE_COMMAND:String="close";
		private static const STREAM_ID_PARAM_NAME:String="streamId";
		private static const VERSION_PARAM_NAME:String="version";
		private static const VERSION_1:String="1";
		private static const CR_BYTE:int=13;
		private static const LF_BYTE:int=10;
		private static const NULL_BYTE:int=0;
		private static const HEX_DIGITS:Object={"48":"0","49":"1","50":"2","51":"3","52":"4","53":"5","54":"6","55":"7","56":"8","57":"9","65":"a","97":"a","66":"b","98":"b","67":"c","99":"c","68":"d","100":"d","69":"e","101":"e","70":"f","102":"f"};
		private static const HEX_VALUES:Object={"0":0,"1":1,"2":2,"3":3,"4":4,"5":5,"6":6,"7":7,"8":8,"9":9,"a":10,"b":11,"c":12,"d":13,"e":14,"f":15};
		private static const INIT_STATE:int=0;
		private static const CR_STATE:int=1;
		private static const LF_STATE:int=2;
		private static const SIZE_STATE:int=3;
		private static const TEST_CHUNK_STATE:int=4;
		private static const SKIP_STATE:int=5;
		private static const DATA_STATE:int=6;
		private static const RESET_BUFFER_STATE:int=7;
		public function StreamingConnectionHandler(channel:Channel,log:ILogger);
		protected var channel:Channel;
		protected var chunkBuffer:ByteArray;
		protected var dataBytesToRead:int;
		protected var dataOffset:int;
		protected var _log:ILogger;
		protected var streamId:String;
		private var hexChunkSize:String;
		private var state:int;
		private var streamingConnection:URLStream;
		private var streamingConnectionCloser:URLStream;
		public function openStreamingConnection(appendToURL:String=null):void;
		public function closeStreamingConnection():void;
		protected function readMessage():IMessage;
		private function convertHexToDecimal(value:String):int;
		private function streamCompleteHandler(event:Event):void;
		private function streamHttpStatusHandler(event:HTTPStatusEvent):void;
		private function streamIoErrorHandler(event:IOErrorEvent):void;
		private function streamOpenHandler(event:Event):void;
		private function streamProgressHandler(event:ProgressEvent):void;
		private function streamSecurityErrorHandler(event:SecurityErrorEvent):void;
	}
}
