package mx.messaging.messages {
	import flash.utils.ByteArray;
	import flash.utils.IDataInput;
	import flash.utils.IDataOutput;
	import flash.utils.getQualifiedClassName;
	import mx.core.mx_internal;
	import mx.utils.RPCObjectUtil;
	import mx.utils.RPCStringUtil;
	import mx.utils.RPCUIDUtil;
	public class AbstractMessage implements IMessage {
		public static const DESTINATION_CLIENT_ID_HEADER:String="DSDstClientId";
		public static const ENDPOINT_HEADER:String="DSEndpoint";
		public static const FLEX_CLIENT_ID_HEADER:String="DSId";
		public static const REMOTE_CREDENTIALS_HEADER:String="DSRemoteCredentials";
		public static const REMOTE_CREDENTIALS_CHARSET_HEADER:String="DSRemoteCredentialsCharset";
		public static const REQUEST_TIMEOUT_HEADER:String="DSRequestTimeout";
		public static const STATUS_CODE_HEADER:String="DSStatusCode";
		private static const HAS_NEXT_FLAG:uint=128;
		private static const BODY_FLAG:uint=1;
		private static const CLIENT_ID_FLAG:uint=2;
		private static const DESTINATION_FLAG:uint=4;
		private static const HEADERS_FLAG:uint=8;
		private static const MESSAGE_ID_FLAG:uint=16;
		private static const TIMESTAMP_FLAG:uint=32;
		private static const TIME_TO_LIVE_FLAG:uint=64;
		private static const CLIENT_ID_BYTES_FLAG:uint=1;
		private static const MESSAGE_ID_BYTES_FLAG:uint=2;
		public function AbstractMessage();
		private var _body:Object;
		public function get body():Object;
		public function set body(value:Object):void;
		private var _clientId:String;
		private var clientIdBytes:ByteArray;
		public function get clientId():String;
		public function set clientId(value:String):void;
		private var _destination:String;
		public function get destination():String;
		public function set destination(value:String):void;
		private var _headers:Object;
		public function get headers():Object;
		public function set headers(value:Object):void;
		private var _messageId:String;
		private var messageIdBytes:ByteArray;
		public function get messageId():String;
		public function set messageId(value:String):void;
		private var _timestamp:Number;
		public function get timestamp():Number;
		public function set timestamp(value:Number):void;
		private var _timeToLive:Number;
		public function get timeToLive():Number;
		public function set timeToLive(value:Number):void;
		public function readExternal(input:IDataInput):void;
		public function toString():String;
		public function writeExternal(output:IDataOutput):void;
		protected function addDebugAttributes(attributes:Object):void;
		final protected function getDebugString():String;
		protected function readFlags(input:IDataInput):Array;
	}
}
