	package mx.rpc.soap {
		import flash.events.Event;
		import flash.xml.XMLNode;
		import mx.core.mx_internal;
		import mx.logging.Log;
		import mx.logging.ILogger;
		import mx.messaging.ChannelSet;
		import mx.messaging.events.MessageEvent;
		import mx.messaging.events.MessageFaultEvent;
		import mx.messaging.messages.IMessage;
		import mx.messaging.messages.SOAPMessage;
		import mx.netmon.NetworkMonitor;
		import mx.resources.IResourceManager;
		import mx.resources.ResourceManager;
		import mx.rpc.AbstractOperation;
		import mx.rpc.AbstractService;
		import mx.rpc.AsyncToken;
		import mx.rpc.Fault;
		import mx.rpc.events.FaultEvent;
		import mx.rpc.events.HeaderEvent;
		import mx.rpc.events.ResultEvent;
		import mx.rpc.soap.AbstractWebService;
		import mx.rpc.wsdl.WSDLOperation;
		import mx.rpc.xml.SchemaConstants;
		import mx.utils.ObjectProxy;
		import mx.utils.XMLUtil;
		public class Operation extends AbstractOperation {
			public function Operation(webService:AbstractService = null, name:String = null);
			private var resourceManager:IResourceManager;
			public function get decoder():ISOAPDecoder;
			public function set decoder(value:ISOAPDecoder):void;
			public function get encoder():ISOAPEncoder;
			public function set encoder(value:ISOAPEncoder):void;
			public function get endpointURI():String;
			public function set endpointURI(uri:String):void;
			public function get forcePartArrays():Boolean;
			public function set forcePartArrays(value:Boolean):void;
			public function get headerFormat():String;
			public function set headerFormat(hf:String):void;
			public function get headers():Array;
			private var _httpHeaders:Object;
			public function get httpHeaders():Object;
			public function set httpHeaders(value:Object):void;
			public function get ignoreWhitespace():Boolean;
			public function set ignoreWhitespace(value:Boolean):void;
			override public function get makeObjectsBindable():Boolean;
			override public function set makeObjectsBindable(value:Boolean):void;
			public function get multiplePartsFormat():String;
			public function set multiplePartsFormat(value:String):void;
			public function get request():Object;
			public function set request(r:Object):void;
			public function get resultFormat():String;
			public function set resultFormat(rf:String):void;
			public function get resultHeaders():Array;
			private var _xmlSpecialCharsFilter:Function;
			public function get xmlSpecialCharsFilter():Function;
			public function set xmlSpecialCharsFilter(func:Function):void;
			mx_internal var handleAxisSession:Boolean;
			mx_internal function get wsdlOperation():WSDLOperation;
			mx_internal function set wsdlOperation(value:WSDLOperation):void;
			public function addHeader(header:Object):void;
			public function addSimpleHeader(qnameLocal:String, qnameNamespace:String, headerName:String, headerValue:String):void;
			override public function cancel(id:String = null):AsyncToken;
			public function clearHeaders():void;
			public function getHeader(qname:QName, headerName:String = null):SOAPHeader;
			public function removeHeader(qname:QName, headerName:String = null):void;
			override public function send(...args:Array):AsyncToken;
			mx_internal function hasPendingInvocations():Boolean;
			mx_internal function invokeAllPending():void;
			mx_internal function invokePendingCall(pc:OperationPendingCall):void;
			override mx_internal function processFault(message:IMessage, token:AsyncToken):Boolean;
			override mx_internal function processResult(message:IMessage, token:AsyncToken):Boolean;
			mx_internal function processSOAP(message:IMessage, token:AsyncToken):Boolean;
			protected function processHeaders(responseHeaders:Array, token:AsyncToken, message:IMessage):Boolean;
			override mx_internal function setService(value:AbstractService):void;
			protected function createFaultEvent(faultCode:String = null, faultString:String = null, faultDetail:String = null):FaultEvent;
			private var _endpointURI:String;
			private var _forcePartArrays:Boolean;
			private var _headerFormat:String;
			private var _headers:Array;
			private var _resultFormat:String;
			private var _makeObjectsBindableSet:Boolean;
			private var _multiplePartsFormat:String;
			private var _decoder:ISOAPDecoder;
			private var _encoder:ISOAPEncoder;
			private var _ignoreWhitespace:Boolean;
			private var log:ILogger;
			private var pendingInvocations:Array;
			private var startTime:Date;
			private var timeout:int;
			private var webService:AbstractWebService;
			protected var _wsdlOperation:mx.rpc.wsdl.WSDLOperation;
		}
	}
	import mx.rpc.AsyncToken;
	class OperationPendingCall {
		public var args:*;
		public var headers:Array;
		public var token:AsyncToken;
		public function OperationPendingCall(args:*, headers:Array, token:AsyncToken);
	}
