package mx.rpc.soap {
	import flash.utils.getTimer;
	import flash.xml.XMLDocument;
	import flash.xml.XMLNode;
	import mx.collections.IList;
	import mx.core.mx_internal;
	import mx.logging.ILogger;
	import mx.logging.Log;
	import mx.rpc.soap.types.ICustomSOAPType;
	import mx.rpc.wsdl.WSDLMessagePart;
	import mx.rpc.wsdl.WSDLConstants;
	import mx.rpc.wsdl.WSDLEncoding;
	import mx.rpc.wsdl.WSDLOperation;
	import mx.rpc.xml.ContentProxy;
	import mx.rpc.xml.DecodingContext;
	import mx.rpc.xml.SchemaConstants;
	import mx.rpc.xml.SchemaDatatypes;
	import mx.rpc.xml.TypeIterator;
	import mx.rpc.xml.XMLDecoder;
	import mx.utils.ObjectProxy;
	import mx.utils.object_proxy;
	import mx.utils.StringUtil;
	import mx.utils.XMLUtil;
	public class SOAPDecoder extends XMLDecoder implements ISOAPDecoder {
		public var supportGenericCompoundTypes:Boolean;
		private var log:ILogger;
		private var _elementsWithId:XMLList;
		private var _forcePartArrays:Boolean;
		private var _headerFormat:String;
		private var _ignoreWhitespace:Boolean;
		private var _multiplePartsFormat:String;
		private var _referencesResolved:Boolean;
		private var _resultFormat:String;
		private var _wsdlOperation:mx.rpc.wsdl.WSDLOperation;
		public static var PI_WHITESPACE_PATTERN:RegExp;
		public function get forcePartArrays():Boolean;
		public function set forcePartArrays(value:Boolean):void;
		public function get headerFormat():String;
		public function set headerFormat(value:String):void;
		public function get ignoreWhitespace():Boolean;
		public function set ignoreWhitespace(value:Boolean):void;
		public function get multiplePartsFormat():String;
		public function set multiplePartsFormat(value:String):void;
		public function get resultFormat():String;
		public function set resultFormat(value:String):void;
		public function get schemaConstants():SchemaConstants;
		public function get soapConstants():SOAPConstants;
		public function get wsdlOperation():WSDLOperation;
		public function set wsdlOperation(value:WSDLOperation):void;
		protected function get inputEncoding():WSDLEncoding;
		protected function get outputEncoding():WSDLEncoding;
		public function SOAPDecoder();
		public function decodeResponse(response:*):SOAPResult;
		protected function decodeEnvelope(responseXML:XML):SOAPResult;
		protected function decodeBody(bodyXML:XML, soapResult:SOAPResult):void;
		protected function decodeFaults(faultsXMLList:XMLList):Array;
		protected function decodeHeaders(headerXML:XML):Array;
		public function decodeComplexType(definition:XML, parent:*, name:QName, value:*, restriction:XML = null, context:DecodingContext = null):void;
		public function decodeType(type:QName, parent:*, name:QName, value:*, restriction:XML = null):void;
		public function decodeComplexRestriction(restriction:XML, parent:*, name:QName, value:*):void;
		public function reset():void;
		protected function parseValue(name:*, value:XMLList):*;
		protected function preProcessXML(root:XML):void;
		private function resolveReferences(root:XML, cleanupElementsWithIdCache:Boolean = true):void;
	}
}
