package mx.rpc.soap {
	import flash.xml.XMLDocument;
	import flash.xml.XMLNode;
	import mx.core.mx_internal;
	import mx.logging.ILogger;
	import mx.logging.Log;
	import mx.resources.IResourceManager;
	import mx.resources.ResourceManager;
	import mx.rpc.soap.types.ICustomSOAPType;
	import mx.rpc.wsdl.WSDLConstants;
	import mx.rpc.wsdl.WSDLEncoding;
	import mx.rpc.wsdl.WSDLOperation;
	import mx.rpc.wsdl.WSDLMessage;
	import mx.rpc.wsdl.WSDLMessagePart;
	import mx.rpc.xml.Schema;
	import mx.rpc.xml.SchemaConstants;
	import mx.rpc.xml.SchemaDatatypes;
	import mx.rpc.xml.SchemaMarshaller;
	import mx.rpc.xml.XMLEncoder;
	public class SOAPEncoder extends XMLEncoder implements ISOAPEncoder {
		private var resourceManager:IResourceManager;
		private var _ignoreWhitespace:Boolean;
		private var isSOAPEncoding:Boolean;
		private var log:ILogger;
		private var _wsdlOperation:WSDLOperation;
		public function get ignoreWhitespace():Boolean;
		public function set ignoreWhitespace(value:Boolean):void;
		protected function get inputEncoding():WSDLEncoding;
		public function get schemaConstants():SchemaConstants;
		public function get soapConstants():SOAPConstants;
		public function get wsdlOperation():WSDLOperation;
		public function set wsdlOperation(value:WSDLOperation):void;
		public function SOAPEncoder();
		public function encodeRequest(args:* = null, headers:Array = null):XML;
		protected function encodeEnvelope(args:*, headers:Array):XML;
		protected function encodeHeaders(headers:Array, envelopeXML:XML):void;
		protected function encodeHeaderElement(header:Object, headersXML:XML):void;
		protected function encodeBody(inputParams:*, envelopeXML:XML):void;
		protected function encodeOperationAsDocumentLiteral(inputParams:Object, bodyXML:XML):void;
		protected function encodeOperationAsRPCLiteral(inputParams:Object, bodyXML:XML):void;
		protected function encodeOperationAsRPCEncoded(inputParams:*, bodyXML:XML):void;
		protected function encodeMessage(inputParams:*, operationXML:XML):void;
		protected function encodePartValue(part:WSDLMessagePart, value:*):XMLList;
		protected function preEncodedCheck(value:*):Object;
		public function encode(value:*, name:QName = null, type:QName = null, definition:XML = null):XMLList;
		public function encodeType(type:QName, parent:XML, name:QName, value:*, restriction:XML = null):void;
		public function encodeComplexRestriction(restriction:XML, parent:XML, name:QName, value:*):void;
		protected function deriveXSIType(parent:XML, type:QName, value:*):void;
	}
}
