package mx.rpc.xml {
	import flash.utils.ByteArray;
	import flash.utils.getQualifiedClassName;
	import mx.collections.ArrayCollection;
	import mx.collections.IList;
	import mx.logging.ILogger;
	import mx.logging.Log;
	import mx.utils.DescribeTypeCache;
	import mx.utils.object_proxy;
	import mx.utils.ObjectProxy;
	import mx.utils.URLUtil;
	import mx.utils.XMLUtil;
	public class XMLDecoder extends SchemaProcessor implements IXMLDecoder {
		public static var listClass:Class;
		protected var document:XML;
		private var log:ILogger;
		private var _makeObjectsBindable:Boolean;
		private var _recordXSIType:Boolean;
		private var _typeRegistry:SchemaTypeRegistry;
		public function get makeObjectsBindable():Boolean;
		public function set makeObjectsBindable(value:Boolean):void;
		public function get recordXSIType():Boolean;
		public function set recordXSIType(value:Boolean):void;
		public function get typeRegistry():SchemaTypeRegistry;
		public function set typeRegistry(value:SchemaTypeRegistry):void;
		public function XMLDecoder();
		public function decode(xml:*, name:QName = null, type:QName = null, definition:XML = null):*;
		public function decodeAll(definition:XML, parent:*, name:QName, valueElements:XMLList, context:DecodingContext = null, isRequired:Boolean = true):Boolean;
		public function decodeAnyType(parent:*, name:QName, valueElements:XMLList):void;
		public function decodeAnyElement(definition:XML, parent:*, name:QName, valueElements:XMLList, context:DecodingContext = null, isRequired:Boolean = true):Boolean;
		public function decodeAnyAttribute(definition:XML, parent:*, value:* = undefined, restriction:XML = null):void;
		public function decodeAttribute(definition:XML, parent:*, value:* = undefined, restriction:XML = null):void;
		public function decodeAttributeGroup(definition:XML, parent:*, value:* = undefined, restriction:XML = null):void;
		public function decodeChoice(definition:XML, parent:*, name:QName, valueElements:XMLList, context:DecodingContext = null, isRequired:Boolean = true):Boolean;
		public function decodeComplexContent(definition:XML, parent:*, name:QName, value:*, context:DecodingContext):void;
		public function decodeComplexExtension(definition:XML, parent:*, name:QName, value:*, context:DecodingContext = null):void;
		public function decodeComplexRestriction(restriction:XML, parent:*, name:QName, value:*):void;
		public function decodeComplexType(definition:XML, parent:*, name:QName, value:*, restriction:XML = null, context:DecodingContext = null):void;
		public function decodeGroupElement(definition:XML, parent:*, valueElements:XMLList, context:DecodingContext = null, isRequired:Boolean = true, hasSiblings:Boolean = true):Boolean;
		public function decodeElementTopLevel(definition:XML, elementQName:QName, value:*):*;
		public function decodeGroupReference(definition:XML, parent:*, name:QName, valueElements:XMLList, context:DecodingContext = null, isRequired:Boolean = true):Boolean;
		public function decodeSequence(definition:XML, parent:*, name:QName, valueElements:XMLList, context:DecodingContext = null, isRequired:Boolean = true):Boolean;
		public function decodeSimpleContent(definition:XML, parent:*, name:QName, value:*, restriction:XML = null):void;
		public function decodeSimpleList(definition:XML, parent:*, name:QName, value:*, restriction:XML = null):void;
		public function decodeSimpleRestriction(restriction:XML, parent:*, name:QName, value:*):void;
		public function decodeSimpleType(definition:XML, parent:*, name:QName, value:*, restriction:XML = null):void;
		public function decodeSimpleUnion(definition:XML, parent:*, name:QName, value:*, restriction:XML = null):void;
		public function decodeType(type:QName, parent:*, name:QName, value:*, restriction:XML = null):void;
		public function marshallBuiltInType(type:QName, parent:*, name:QName, value:*, restriction:XML = null):*;
		public function reset():void;
		public function getAttribute(parent:*, name:*):*;
		public function hasAttribute(parent:*, name:*):Boolean;
		public function setAttribute(parent:*, name:*, value:*):void;
		public function getProperties(value:*):Array;
		public function createContent(type:QName = null):*;
		public function isSimpleValue(value:*):Boolean;
		public function getSimpleValue(parent:*, name:*):*;
		public function setSimpleValue(parent:*, name:*, value:*, type:Object = null):void;
		public function getValue(parent:*, name:*, index:Number = -1):*;
		public function hasValue(parent:*, name:*):Boolean;
		public function setValue(parent:*, name:*, value:*, type:Object = null):void;
		public function createIterableValue(type:Object = null):*;
		protected function getApplicableValues(parent:*, valueElements:XMLList, name:QName, context:DecodingContext, maxOccurs:uint):XMLList;
		protected function includeNamespace(namespaceURI:String, includedNamespaces:Array = null):Boolean;
		protected function parseValue(name:*, value:XMLList):*;
		protected function isXSINil(value:*):Boolean;
		protected function promoteValueToArray(value:*, type:Object = null):*;
		protected function getXSIType(value:*):QName;
		protected function setXSIType(value:*, type:QName):void;
		protected function getExistingValue(parent:*, propertyName:String):*;
		protected function preProcessXML(root:XML):void;
	}
}
